
function block_info(B, full)

%BLOCK_INFO displays all parameters of the block
% 
% syntax:
% block_info(B)
% block_info(B, full)
%
% input:
% B    - handle to block
% full - a flag determining if block properties should be displayed
%
% examples:
%
% b = pyramid(2,1,1);
% block_info(b)
% creates a pyramid with default properties and displays its parameters
% 
% b = pyramid(2,1,1);
% block_info(b,1)
% creates a pyramid with default properties, next displays its parameters
% and properties
%
% See also: BLOCK, BLOCK_GET, BLOCK_SET
%

if ( ~parIsObj(B,'block') ) rethrow(geterr('argValObj', 'B', 'block')); end
if ( nargin < 2 ) full=0; end

blkinfo(B, full);
