
function csys_info(CS, full)

%CSYS_INFO displays all parameters of the coordinate system
% 
% syntax:
% csys_info(CS)
% csys_info(CS, full)
%
% input:
% CS   - handle to coordinate system
% full - a flag determining if coordinate system properties should be displayed
%
% examples:
%
% cs = csys(eye(4))
% csys_info(cs)
% creates a new coordinate sytem with default properties and displays 
% its parameters
% 
% cs = csys(eye(4))
% csys_info(cs,1)
% creates a new coordinate sytem with default properties and displays 
% its parameters and properties
%
% See also: CSYS, CSYS_GET, CSYS_SET
%

if ( ~parIsObj(CS,'csys') ) rethrow(geterr('argValObj', 'CS', 'csys')); end
if ( nargin < 2 ) full=0; end

csinfo(CS, full);
