
% ------------------------------------------------------------------------
% DEMO_BLOCKS3
% Demo program of ROBOT toolbox
% Animated block created by the connecion of cube, pyramid and two cuboid
% ------------------------------------------------------------------------

axis([-3 15 -3 15 -1 15]);
cs = csys(eye(4), 'CSysAxisLength', axis);
csys_plot(cs);

b1 = cube(2); 
block_set(b1, 'BlockColor', 'r');
b2 = block_move(pyramid(2,2,2),[0;0;2]); 
block_set(b2, 'BlockColor', 'm');
b3 = block_move(cuboid(1,1,2), rp2t(rotx(pi/2),[0;-1;1]));
block_set(b3, 'BlockColor', 'b');
b4 = block_move(cuboid(1,1,2), rp2t(rotx(-pi/2),[0;1;1]));
block_set(b4, 'BlockColor', 'b');

b5 = block_complex(b1,b2,b3,b4);
block_plot(b5);

T1 = {};  i = 1;
for fi=0:0.1:2*pi 
  T1{i} = rp2t(rotx(fi),[sin(2*fi)+0.2*i;cos(fi)+0.2*i;0.15*i]); 
  i = i+1;
end

b6 = block_move(cube(2), rp2t(eye(3),[13;0;13]));
block_plot(b6);

T2 = {};  i = 1;
for j=13:-0.25:0 
  T2{i} = rp2t(eye(3),[j;0;j]); 
  i = i+1;
end

block_motion(b5, T1, b6, T2, 0.05);
