
function demo_rhand

q1 = -pi/8;  q2 = pi/4;  q3 = pi/4;  q4 = pi/4;

f1 = robot( [dh(pi,0,0,q1); dh(-pi/2,0.015,0,q2); dh(0,0.05,0,q3); dh(0,0.04,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', rp2t(roty(pi/2),[0.04;0.03;-0.015]),...
            'RobotRange', [-pi/2, 0; pi/4, pi; 0, pi/2; 0, pi/2],...
            'RobotGrasper', [0.03; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotLineWidth', 3,...
            'RobotCylinderRadius', 0.012,...
            'RobotCylinderApprox', 16,...
            'CSysAxisLength', 0.1);

q1 = 0;  q2 = -pi/16;  q3 = -pi/8;  q4 = -pi/8;

f2 = robot( [dh(pi,0,0,q1); dh(-pi/2,0,0,q2); dh(0,0.05,0,q3); dh(0,0.03,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', [0.1;0.025;0],...
            'RobotRange', [-1/9*pi, 0; -pi/2, 0; -pi/2, 0; -pi/2, 0],...
            'RobotGrasper', [0.025; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotLineWidth', 3,...
            'RobotCylinderRadius', 0.01,...
            'RobotCylinderApprox', 16,...
            'CSysAxisLength', 0.1);

f3 = robot( [dh(pi,0,0,q1); dh(-pi/2,0,0,q2); dh(0,0.055,0,q3); dh(0,0.035,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', [0.1;0;0],...
            'RobotRange', [-1/18*pi, 1/18*pi; -pi/2, 0; -pi/2, 0; -pi/2, 0],...
            'RobotGrasper', [0.025; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotLineWidth', 3,...
            'RobotCylinderRadius', 0.01,...
            'RobotCylinderApprox', 16,...
            'CSysAxisLength', 0.1);

f4 = robot( [dh(pi,0,0,q1); dh(-pi/2,0,0,q2); dh(0,0.05,0,q3); dh(0,0.03,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', [0.09;-0.02;0],...
            'RobotRange', [0, 1/9*pi; -pi/2, 0; -pi/2, 0; -pi/2, 0],...
            'RobotGrasper', [0.025; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotLineWidth', 3,...
            'RobotCylinderRadius', 0.009,...
            'RobotCylinderApprox', 16,...
            'CSysAxisLength', 0.1);

f5 = robot( [dh(pi,0,0,q1); dh(-pi/2,0,0,q2); dh(0,0.04,0,q3); dh(0,0.025,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', [0.08;-0.04;0],...
            'RobotRange', [0, 1/5*pi; -pi/2, 0; -pi/2, 0; -pi/2, 0],...
            'RobotGrasper', [0.023; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotLineWidth', 3,...
            'RobotCylinderRadius', 0.008,...
            'RobotCylinderApprox', 16,...
            'CSysAxisLength', 0.1);
        
rhand = robot_complex(f1, f2, f3, f4, f5, ...
                     'RobotBase', [0;0;0], ...   
                     'RobotModel', 'configex', ...
                     'RobotLineWidth', 3,...
                     'RobotCylinderRadius', 0.01,...
                     'CSysAxisLength', 0.2);


q1 = 0;  q2 = -pi/2;  q3 = 0;  q4 = pi;  q5 = pi/2;  q6 = pi/2;  q7 = pi;

l1 = 0.25;  l2 = 0.25;

rlimb = robot( [dh(0,0,0,q1); dh(pi/2,0,0,q2); dh(pi/2,0,0,q3); dh(0,l1,0,q4); dh(pi/2,0,l2,q5); dh(-pi/2,0,0,q6); dh(pi/2,0,0,q7)], ['r', 'r', 'r', 'r', 'r', 'r', 'r'], ...
              'RobotRange', [-pi/2,pi/2; -pi,-pi/2; -pi/4,pi; pi/2,5*pi/4; -pi/2,pi; pi/4,3*pi/4; 3*pi/4,3*pi/2], ...
              'RobotColor', 'b',...
              'RobotLineWidth', 3,...
              'RobotCylinderRadius', 0.02,...
              'RobotCylinderApprox', 16,...
              'CSysAxisLength', 0.2);
          
robot_connect(rlimb, rhand);

% fingers appearance

b1 = block_move(cuboid(0.04,0.007,0.007,'BlockColor',[0.85,0.85,0.85]),[0.01;0;-0.0035]);
robot_part(f1,1,b1)

b1 = block_move(cuboid(0.03,0.02,0.02,'BlockColor',[0.85,0.85,0.85]),[0.025;0;-0.01]);
b2 = block_move(prism([[0.01;0.01] [0;0.01] [-0.01;0] [-0.01;-0.01] [0.01;-0.01]], 0.007), [0;0;0.003]);
b3 = block_move(prism([[0.01;0.01] [0;0.01] [-0.01;0] [-0.01;-0.01] [0.01;-0.01]], 0.007), [0;0;-0.01]);
b4 = block_move(prism([[-0.01;-0.01] [0.01;-0.01] [0.01;0] [0;0.01] [-0.01;0.01]], 0.007), [0.05;0;-0.01]);
b5 = block_move(prism([[-0.01;-0.01] [0.01;-0.01] [0.01;0] [0;0.01] [-0.01;0.01]], 0.007), [0.05;0; 0.003]);
robot_part(f1,2,block_merge(b1,b2,b3,b4,b5))

b1 = block_move(cuboid(0.02,0.01,0.005,'BlockColor',[0.85,0.85,0.85]),[0;0;-0.0025]);
b2 = block_move(cuboid(0.02,0.02,0.02),[0.02;0;-0.01]);
b3 = block_move(prism([[-0.01;-0.01] [0.01;-0.01] [0.01;0] [0;0.01] [-0.01;0.01]], 0.007), [0.04;0;-0.01]);
b4 = block_move(prism([[-0.01;-0.01] [0.01;-0.01] [0.01;0] [0;0.01] [-0.01;0.01]], 0.007), [0.04;0; 0.003]);
robot_part(f1,3,block_merge(b1,b2,b3,b4));

b1 = block_move(cuboid(0.02,0.01,0.005,'BlockColor',[0.85,0.85,0.85]),[0;0;-0.0025]);
b2 = block_move(cuboid(0.01,0.02,0.02),[0.015;0;-0.01]);
b3 = block_move(prism(arc([0.02;0.01],[0.02;-0.01],0.01), 0.02), [0;0;-0.01]);
robot_part(f1,4,block_merge(b1,b2,b3));

F = [f2 f3 f4 f5];
L1 = [0.05 0.055 0.05 0.04];
L2 = [0.03 0.035 0.03 0.025];
L3 = [0.025 0.025 0.025 0.023];
R  = [0.01 0.01 0.009 0.008];

for i=1:4
  f = F(i);   l1 = L1(i);  l2 = L2(i);   l3 = L3(i);   r = R(i);
  
  b1 = block_move(cuboid(0.02,r,0.005,'BlockColor',[0.85,0.85,0.85]),[0;0;-0.0025]);
  b2 = block_move(cuboid(l1-0.02,2*r,2*r),[0.01+(l1-0.02)/2;0;-r]);
  b3 = block_move(prism([[-0.01;-r] [0;-r] [0.01;0] [0.01;r] [-0.01;r]], r-0.003), [l1;0;-r]);
  b4 = block_move(prism([[-0.01;-r] [0;-r] [0.01;0] [0.01;r] [-0.01;r]], r-0.003), [l1;0;0.003]);
  robot_part(f, 2, block_merge(b1,b2,b3,b4))

  b1 = block_move(cuboid(0.02,r,0.005,'BlockColor',[0.85,0.85,0.85]),[0;0;-0.0025]);
  b2 = block_move(cuboid(l2-0.02,2*r,2*r),[0.01+(l2-0.02)/2;0;-r]);
  b3 = block_move(prism([[-0.01;-r] [0;-r] [0.01;0] [0.01;r] [-0.01;r]], r-0.003), [l2;0;-r]);
  b4 = block_move(prism([[-0.01;-r] [0;-r] [0.01;0] [0.01;r] [-0.01;r]], r-0.003), [l2;0;0.003]);
  robot_part(f, 3, block_merge(b1,b2,b3,b4));

  b1 = block_move(cuboid(0.02,r,0.005,'BlockColor',[0.85,0.85,0.85]),[0;0;-0.0025]);
  b2 = block_move(cuboid(l3-0.02,2*r,2*r),[0.01+(l3-0.02)/2;0;-r]);
  b3 = block_move(prism(arc([l3-0.01;r],[l3-0.01;-r],r), 2*r), [0;0;-r]);
  robot_part(f, 4, block_merge(b1,b2,b3));
end

% hand appearance

pt = [[0;0.02;0.015] [0.02;0.04;0.015] [0.11;0.04;0.015] [0.11;0.028;0.015] [0.09;0.028;0.015] [0.09;0.022;0.015] [0.11;0.022;0.015] [0.11;0.003;0.015] [0.09;0.003;0.015] [0.09;-0.003;0.015] [0.11;-0.003;0.015] [0.11;-0.01;0.015] [0.1;-0.011;0.015] [0.1;-0.017;0.015] [0.08;-0.017;0.015] [0.08;-0.023;0.015] [0.1;-0.023;0.015] [0.1;-0.029;0.015] [0.09;-0.032;0.015] [0.09;-0.037;0.015] [0.07;-0.037;0.015] [0.07;-0.043;0.015] [0.09;-0.043;0.015] [0.09;-0.05;0.015] [0.02;-0.05;0.015] [0;-0.03;0.015]...
      [0;0.02;-0.015] [0.02;0.04;-0.015] [0.095;0.04;-0.015] [0.095;0.028;-0.015] [0.09;0.028;-0.015] [0.09;0.022;-0.015] [0.095;0.022;-0.015] [0.095;0.003;-0.015] [0.09;0.003;-0.015] [0.09;-0.003;-0.015] [0.095;-0.003;-0.015] [0.095;-0.01;-0.015] [0.085;-0.011;-0.015] [0.085;-0.017;-0.015] [0.08;-0.017;-0.015] [0.08;-0.023;-0.015] [0.085;-0.023;-0.015] [0.085;-0.029;-0.015] [0.075;-0.032;-0.015] [0.075;-0.037;-0.015] [0.07;-0.037;-0.015]  [0.07;-0.043;-0.015]   [0.075;-0.043;-0.015] [0.075;-0.05;-0.015] [0.02;-0.05;-0.015] [0;-0.03;-0.015]...
      [0;0.02;0] [0.02;0.04;0] [0.11;0.04;0] [0.11;0.028;0] [0.09;0.028;0] [0.09;0.022;0] [0.11;0.022;0] [0.11;0.003;0] [0.09;0.003;0] [0.09;-0.003;0] [0.11;-0.003;0] [0.11;-0.01;0] [0.1;-0.011;0] [0.1;-0.017;0] [0.08;-0.017;0] [0.08;-0.023;0] [0.1;-0.023;0] [0.1;-0.029;0] [0.09;-0.032;0] [0.09;-0.037;0] [0.07;-0.037;0] [0.07;-0.043;0] [0.09;-0.043;0] [0.09;-0.05;0] [0.02;-0.05;0] [0;-0.03;0]];
fc = { [1:26; 27:52], ...
       [3 4 56 55; 7 8 60 59; 11 12 64 63; 12 13 65 64; 13 14 66 65; 17 18 70 69; 18 19 71 70; 19 20 72 71; 23 24 76 75; ...\
        29 30 56 55; 33 34 60 59; 37 38 64 63; 38 39 65 64; 39 40 66 65; 43 44 70 69; 44 45 71 70; 45 46 72 71; 49 50 76 75; ...
        5 6 32 31; 9 10 36 35; 15 16 42 41; 21 22 48 47], ...
       [4 5 31 30 56; 7 6 32 33 59; 8 9 35 34 60; 11 10 36 37 63; 14 15 41 40 66; 17 16 42 43 69; 20 21 47 46 72; 23 22 48 49 75; ...
        3 2 28 29 55; 24 25 51 50 76], [1 2 28 27; 1 27 52 26; 25 26 52 51]};
robot_part(rhand, block(pt, fc, 'BlockColor', [0.85, 0.85, 0.85]));

b1 = block_move(prism([[0;0.05] [-0.025;0.025] [-0.025;-0.025] [0;-0.05] [0.21;-0.04] [0.21;0.04]],0.05,'BlockColor',[0.85,0.85,0.85]), [0;0;-0.025]);
b2 = block_move(prism([[-0.04;0.04] [-0.04;-0.04] [0.04;-0.04] [0.04;0] [0;0.04]],0.015), [0.25;0; 0.01]);
b3 = block_move(prism([[-0.04;0.04] [-0.04;-0.04] [0.04;-0.04] [0.04;0] [0;0.04]],0.015), [0.25;0; -0.025]);
robot_part(rlimb,3,block_merge(b1,b2,b3))

% arm appearance

b1 = block_move(cuboid(0.04,0.11,0.02,'BlockColor',[0.85,0.85,0.85]),[0;-0.035;-0.01]);
pt = [[-0.01;-0.04;0.025] [-0.04;-0.04;0.025] [-0.04;-0.04;-0.025] [-0.01;-0.04;-0.025]...
      [0.04;-0.09;-0.025] [0.04;-0.09;0.025]...
      [0.02;-0.21;0.015] [-0.03;-0.21;0.015] [-0.03;-0.21;-0.015] [0.02;-0.21;-0.015]];
pt = [[-0.01;-0.05;0.025] [-0.04;-0.05;0.025] [-0.04;-0.05;-0.025] [-0.01;-0.05;-0.025]...
      [0.04;-0.105;-0.025] [0.04;-0.105;0.025]...
      [0.02;-0.21;0.015] [-0.03;-0.21;0.015] [-0.03;-0.21;-0.015] [0.02;-0.21;-0.015]];
fc = {[1:4; 1 4 5 6; 7:10; 5 10 7 6; 2 3 9 8], [1 2 8 7 6; 4 3 9 10 5]};
b2 = block(pt, fc);
b3 = block_move(cylinder(0.015,0.05), rp2t(rotx(pi/2),[0;-0.21;0]));
robot_part(rlimb, 4, block_merge(b1,b2,b3));

armfig(rlimb, 160, 40);

axis([-0.5 0.5 -0.5 0.5 -0.5 0.5]);
csys_plot(csys(eye(4), 'CsysAxisLength', axis))
view(-25,25); camlight

robot_plot(rlimb, 'line');

end


function armfig(r, wfig, hfig)

global RTHND;

% clc
wpnl = 45;
hpnl = 5;
   
ud.OBJ = r;

fig = figure('Units', 'characters');  
pfig = get(fig, 'Position');  
pfig = [pfig(1) pfig(2)+(pfig(4)-hfig) wfig hfig];
set(fig, 'Position', pfig);
c    = get(0,'DefaultUicontrolBackgroundColor');
    
lpnl = uipanel('Parent',fig,...
               'BorderType','none', 'BackgroundColor',c,...
               'Units','characters', 'Position',[0 0 wpnl pfig(4)]);
ppnl = get(lpnl, 'Position'); 
    
vgrp = uigrp(lpnl, 'View ', ppnl(3)-2,...
            'Style','radiobutton', 'String','Line',              'Tag','line',...
            'Style','radiobutton', 'String','Default 3D (mesh)', 'Tag','dmesh',...
            'Style','radiobutton', 'String','Default 3D (surf)', 'Tag','dsurf',...
            'Style','radiobutton', 'String','User 3D (mesh)',    'Tag','umesh',...
            'Style','radiobutton', 'String','User 3D (surf)',    'Tag','usurf');
      
        
[cstab,cspnl] = uitabcontrol('Parent', lpnl, 'TabCaptions', {'arm','hand','f1','f2','f3','f4','f5'},...
                             'Units', 'Characters', 'Position',[1,5,ppnl(3)-2,15]);  

height = 0;  arg = {};
for i=1:RTHND{r}.n
  arg = { arg{:}, 'Style','checkbox', 'String',sprintf('%d. joint',i),...
                  'Callback',{@onCSClick,r,i+1} };
end              
arg = { 'Style','checkbox', 'String','Base', 'Callback',{@onCSClick,r,1},...
         arg{:},...
        'Style','checkbox', 'String','Grasper', 'Callback',{@onCSClick,r,RTHND{r}.n+2} };
[csgrp(1),h] = uigrp(cspnl(1), 'Arm''s coordinate systems', ppnl(3)-4.5, arg{:});
p = get(csgrp(1),'Position');  set(csgrp(1),'Position',[1,0.5,p(3:4)]);
height = max(height,h);

hand = RTHND{r}.bond;

[csgrp(2),h] = uigrp(cspnl(2), 'Hand''s coordinate system ', ppnl(3)-4.5,...
                    'Style','checkbox', 'String','Base', 'Callback',{@onCSClick,hand,1});
p = get(csgrp(2),'Position');  set(csgrp(2),'Position',[1,0.5,p(3:4)]);
height = max(height,h);

for i=1:length(RTHND{hand}.robots)                  
  arg = {};
  for j=1:RTHND{RTHND{hand}.robots(i)}.n
    arg = { arg{:}, 'Style','checkbox', 'String',sprintf('%d. joint',j),...
                    'Callback',{@onCSClick,RTHND{hand}.robots(i),j+1} };
  end              
  arg = {'Style','checkbox', 'String','Base', 'Callback',{@onCSClick,RTHND{hand}.robots(i),1},...
          arg{:},...
         'Style','checkbox', 'String','Grasper',...
         'Callback',{@onCSClick,RTHND{hand}.robots(i),RTHND{RTHND{hand}.robots(i)}.n+2}};
  [csgrp(i+2),h] = uigrp(cspnl(i+2), sprintf('Coordinate systems f%d',i), ppnl(3)-4.5, arg{:});
  p = get(csgrp(i+2),'Position');  set(csgrp(i+2),'Position',[1,0.5,p(3:4)]);
  height = max(height,h);
end

p = get(cstab,'Position');  set(cstab,'Position',[p(1:3),height+3.5]);
p1 = get(csgrp(1),'Position');
for i=2:length(csgrp)
  p2 = get(csgrp(i),'Position');
  set(csgrp(i),'Position',[p2(1),p1(2)+p1(4)-p2(4),p2(3:4)]);
end


[mgrp,h,btns] = uigrp(lpnl, 'Model ', ppnl(3)-2,...
              'Style','radiobutton', 'String','config',   'Tag','config',...
              'Style','radiobutton', 'String','configex', 'Tag','configex',...
              'Style','radiobutton', 'String','range',    'Tag','range',...
              'Style','radiobutton', 'String','rangeex',  'Tag','rangeex');
switch( robot_get(r, 'RobotModel') )
  case 'config',   set(btns(1), 'Value', 1);
  case 'configex', set(btns(2), 'Value', 1);
  case 'range',    set(btns(3), 'Value', 1);
  case 'rangeex',  set(btns(4), 'Value', 1);
end
set(mgrp, 'Visible', 'off');


btn = uicontrol('Parent',lpnl, 'Style','pushbutton', 'String','Panel',...
                'Units','characters', 'Position',[1,0.5,ppnl(3)-2,2],...
                'Callback',@onBtnPanelClick);


tpnl = uipanel('Parent',fig, 'BorderType','none', 'BackgroundColor',c,...
               'Units','characters', 'Position',[wpnl pfig(4)-hpnl pfig(3)-wpnl hpnl]);
agrp = uibuttongroup('Parent',tpnl, 'BorderType','etchedin',...
                     'Title','Animations', 'Units','character');
uicontrol('Parent',agrp, 'Style','pushbutton', 'String','Hello',...
          'Units','characters', 'Position',[1,0.5,15,2], 'Callback',{@onAnimationClick,'hello'});
uicontrol('Parent',agrp, 'Style','pushbutton', 'String','OK',...
          'Units','characters', 'Position',[17,0.5,15,2], 'Callback',{@onAnimationClick,'ok'});
uicontrol('Parent',agrp, 'Style','pushbutton', 'String','All right',...
          'Units','characters', 'Position',[33,0.5,15,2], 'Callback',{@onAnimationClick,'allright'});
uicontrol('Parent',agrp, 'Style','pushbutton', 'String','Victoria',...
          'Units','characters', 'Position',[49,0.5,15,2], 'Callback',{@onAnimationClick,'victoria'});
uicontrol('Parent',agrp, 'Style','pushbutton', 'String','Down',...
          'Units','characters', 'Position',[65,0.5,15,2], 'Callback',{@onAnimationClick,'down'});


rpnl = uipanel('Parent',fig, 'BorderType','etchedin', 'BackgroundColor',c,...
               'Units','characters', 'Position',[wpnl 0 pfig(3)-wpnl pfig(4)-hpnl]);
axs = axes('Parent', rpnl);
grid on

set(fig,  'ResizeFcn', {@onFigResize, lpnl, rpnl, tpnl});
set(lpnl, 'ResizeFcn', {@onLPnlResize, vgrp, cstab, mgrp});
set(tpnl, 'ResizeFcn', {@onTPnlResize, agrp});
set(vgrp, 'SelectionChangeFcn', {@onViewClick, mgrp});
set(mgrp, 'SelectionChangeFcn', @onModelClick);

onLPnlResize(lpnl, [], vgrp, cstab, mgrp);
    
set(fig,'UserData', ud);


function onFigResize(hnd, data, lpnl, rpnl, tpnl)

pfig = get(hnd, 'Position');
set(lpnl, 'Position', [0 0 wpnl pfig(4)]);
set(tpnl, 'Position', [wpnl pfig(4)-hpnl pfig(3)-wpnl hpnl]);
set(rpnl, 'Position', [wpnl 0 pfig(3)-wpnl pfig(4)-hpnl]);

end


function onLPnlResize(hnd, data, vgrp, ctab, mgrp)

ppnl = get(hnd, 'Position');
pos  = get(vgrp, 'Position');  y = ppnl(4)-pos(4)-0.5;
set(vgrp, 'Position', [1,y,pos(3:4)]);
pos  = get(ctab, 'Position');  y = y-pos(4)-1;
set(ctab, 'Position', [1,y,pos(3),pos(4)]);
pos  = get(mgrp, 'Position');  y = y-pos(4)-0.5;
set(mgrp, 'Position', [1,y,pos(3),pos(4)]);

end


function onTPnlResize(hnd, data, agrp)

ppnl = get(hnd, 'Position');
set(agrp, 'Position', [0,0.5,ppnl(3),ppnl(4)-1]);

end


function onViewClick(hnd, data, mgrp)
    
fig = get(get(hnd,'Parent'),'Parent');
ud = get(fig, 'UserData');  r = ud.OBJ
view = get(data.NewValue, 'Tag');
rdel(r, 'robot', 0);
robot_plot(r, view);

if (( strcmpi(view,'dmesh') | strcmpi(view,'dsurf') )) 
  set(mgrp, 'Visible', 'on');
else set(mgrp, 'Visible', 'off'); end

end


function onCSClick(hnd, data, r, nr)
    
cs = RTHND{r}.csys.view;
cs(nr) = get(hnd, 'Value');
robot_delete(r, 'csys');
if ( parIsObj(r,'robot:complex') ) robot_plot_csys(r, cs);
else robot_plot_csys(r, cs(2:length(cs)-1), cs(1), cs(length(cs))); end

end


function onModelClick(hnd, data)
    
fig = get(get(hnd,'Parent'),'Parent');
ud = get(fig, 'UserData');  r = ud.OBJ;
model = get(data.NewValue, 'Tag');
robot_set(r, 'RobotModel', model);

end


function onBtnPanelClick(hnd, data)
    
fig = get(get(hnd,'Parent'), 'Parent');
ud  = get(fig,'UserData');
robot_panel(ud.OBJ);

end


function onAnimationClick(hnd, data, anim)
    
fig = get(get(get(hnd,'Parent'), 'Parent'), 'Parent');
ud  = get(fig,'UserData');

q0 = robot_config(ud.OBJ);
switch ( anim )
  case 'hello',    qt = [-pi/2;-pi/2;pi/2;pi;pi/2;pi/2;pi; -pi/2;pi/2; 0; 0; repmat([0;0;0;0],4,1)];
  case 'ok',       qt = [-pi/4;-pi/2;pi/4;3*pi/4;pi/2;pi/2;pi; -pi/2;0;0;0; repmat([0;-pi/2;-pi/2;-pi/2],4,1)];
  case 'allright', qt = [pi/4;-pi/2;pi/4;pi;0;3*pi/4;pi; 0;0;1;1; 0;-1;-1;-0.7; 0;-0.75;-0.6;-0.6; 0;-0.3;-0.6;-0.6; 0;0;-0.6;-0.6];
  case 'victoria', qt = [-pi/2;-pi/2;pi/2;pi;pi/2;pi/2;pi; -pi/2;2;pi/2;pi/4; -0.2;0;0;0; 0.1;0;0;0; 0;-pi/4;-pi/2;-pi/2; 0;-pi/4;-pi/2;-pi/2];
  case 'down',     qt = [0;-pi/2;0;pi;pi/2;pi/2;pi; -pi/8;pi/4;pi/4;pi/4; repmat([0;-pi/16;-pi/8;-pi/8],4,1)];
end

% q0'

% qt'

q = trj_poly3(0:0.125:5, q0, qt);
robot_motion(ud.OBJ, q);

end


end
