
% ------------------------------------------------------------------------
% DEMO_ROBOT 2.0
% Demo program of ROBOT toolbox 2.0
% ------------------------------------------------------------------------

function demo_robot2(act);

if  ( nargin == 0 ) act='init'; end

switch ( act )
    
  case 'init'
    s = 10;  nr = 4;
    scr = get(0,'ScreenSize'); 
    fig = figure;   
    set(fig, 'MenuBar', 'none', 'Name', 'Demo ROBOT', 'NumberTitle', 'off');
    w = nr*3.5*s+s; pos=[25,scr(4)-w-60,17*s,w];
    set(fig,'Position', pos);
    for i=1:nr p(i,:)=[s, pos(4)-i*3.5*s, 15*s, 3*s]; end
    
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(1,:),...
              'String', 'Right hand 1', 'CallBack', 'demo_robot2(''RH_1'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(2,:),...
              'String', 'Right hand 2', 'CallBack', 'demo_robot2(''RH_2'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(3,:),...
              'String', 'Right arm 1', 'CallBack', 'demo_robot2(''RA_1'')');
    uicontrol(fig,'Style', 'pushbutton', 'Units', 'pixels', 'Position',p(4,:),...
              'String', 'Right arm 2', 'CallBack', 'demo_robot2(''RA_2'')');
    
    case 'RH_1',     figure; right_hand;
    case 'RH_2',     demo_rhand;
    case 'RA_1',     figure; right_arm;
    case 'RA_2',     demo_rarm;
      
end;
