
function demofig(r, wfig, hfig)

global RTHND;

wpnl = 30;  
   
ud.OBJ = r;

fig = figure('Units', 'characters');  
pfig = get(fig, 'Position');  
pfig = [pfig(1) pfig(2)+(pfig(4)-hfig) wfig hfig];
set(fig, 'Position', pfig);
c    = get(0,'DefaultUicontrolBackgroundColor');
    
lpnl = uipanel('BorderType','none', 'BackgroundColor',c,...
               'Units','characters', 'Position',[0 0 wpnl pfig(4)],...
               'Parent',fig);
ppnl = get(lpnl, 'Position'); 
    
vgrp = uigrp(lpnl, 'View ', ppnl(3)-2,...
            'Style','radiobutton', 'String','Line',              'Tag','line',...
            'Style','radiobutton', 'String','Default 3D (mesh)', 'Tag','dmesh',...
            'Style','radiobutton', 'String','Default 3D (surf)', 'Tag','dsurf',...
            'Style','radiobutton', 'String','User 3D (mesh)',    'Tag','umesh',...
            'Style','radiobutton', 'String','User 3D (surf)',    'Tag','usurf');

arg = {};
for i=1:RTHND{r}.n
  arg = { arg{:},...
         'Style','checkbox',...
         'String',sprintf('%d. joint', i),...
         'Callback',{@onCSClick, i+1} };
end              
arg = {'Style','checkbox', 'String','Base', 'Callback',{@onCSClick, 1},...
        arg{:},...
       'Style','checkbox', 'String','Grasper', 'Callback',{@onCSClick, RTHND{r}.n+2} };
csgrp = uigrp(lpnl, 'Coordinate systems ', ppnl(3)-2, arg{:});

btn = uicontrol(lpnl, 'Style','pushbutton', 'String','Panel',...
                'Units','characters', 'Position',[1,0.5,ppnl(3)-2,2],...
                'Callback',@onBtnPanelClick);

mgrp = 0;            
if ( parIsObj(r, 'robot:manip') )
  [mgrp,h,btns] = uigrp(lpnl, 'Model ', ppnl(3)-2,...
                'Style','radiobutton', 'String','config',   'Tag','config',...
                'Style','radiobutton', 'String','configex', 'Tag','configex',...
                'Style','radiobutton', 'String','range',    'Tag','range',...
                'Style','radiobutton', 'String','rangeex',  'Tag','rangeex');
  switch( robot_get(r, 'RobotModel') )
    case 'config',   set(btns(1), 'Value', 1);
    case 'configex', set(btns(2), 'Value', 1);
    case 'range',    set(btns(3), 'Value', 1);
    case 'rangeex',  set(btns(4), 'Value', 1);
  end
  set(mgrp, 'Visible', 'off');
end
            
rpnl = uipanel('BorderType','etchedin', 'BackgroundColor',c,...
               'Units','characters', 'Position',[wpnl 0 pfig(3)-wpnl pfig(4)],...
               'Parent',fig);
axs = axes('Parent', rpnl);
grid on
camlight

set(fig,  'ResizeFcn', {@onFigResize, lpnl, rpnl});
set(lpnl, 'ResizeFcn', {@onLPnlResize, vgrp, csgrp, mgrp});
set(vgrp, 'SelectionChangeFcn', {@onViewClick, mgrp});
set(mgrp, 'SelectionChangeFcn', @onModelClick);

onLPnlResize(lpnl, [], vgrp, csgrp, mgrp);
    
set(fig,'UserData', ud);



function onFigResize(hnd, data, lpnl, rpnl)

fig  = get(lpnl, 'Parent');
p    = get(fig, 'Position');
set(lpnl, 'Position', [0 0 wpnl p(4)]);
set(rpnl, 'Position', [wpnl 0 p(3)-wpnl p(4)]);

end


function onLPnlResize(hnd, data, vgrp, cgrp, mgrp)

ppnl = get(hnd, 'Position');
pgrp = get(vgrp, 'Position');  p = ppnl(4)-pgrp(4)-0.5;
set(vgrp, 'Position', [1,p,pgrp(3),pgrp(4)]);
pgrp = get(cgrp, 'Position');  p = p-pgrp(4)-0.5;
set(cgrp, 'Position', [1,p,pgrp(3),pgrp(4)]);
if ( mgrp ~= 0 )
  pgrp = get(mgrp, 'Position');  p = p-pgrp(4)-0.5;
  set(mgrp, 'Position', [1,p,pgrp(3),pgrp(4)]);
end

end


function onViewClick(hnd, data, mgrp)
    
fig = get(get(hnd,'Parent'),'Parent');
ud = get(fig, 'UserData');  r = ud.OBJ;
view = get(data.NewValue, 'Tag');
% robot_delete(r, 'robot');
rdel(r, 'robot', 0);
robot_plot(r, view);

if (( mgrp ~= 0 ) & ( strcmpi(view,'dmesh') | strcmpi(view,'dsurf') )) 
  set(mgrp, 'Visible', 'on');
else set(mgrp, 'Visible', 'off'); end

end


function onCSClick(hnd, data, nr)
    
fig = get(get(get(hnd,'Parent'),'Parent'),'Parent');
ud = get(fig, 'UserData');  r = ud.OBJ;
cs = RTHND{r}.csys.view;
cs(nr) = get(hnd, 'Value');
robot_delete(r, 'csys');
robot_plot_csys(r, cs(2:length(cs)-1), cs(1), cs(length(cs)));

end


function onModelClick(hnd, data)
    
fig = get(get(hnd,'Parent'),'Parent');
ud = get(fig, 'UserData');  r = ud.OBJ;
model = get(data.NewValue, 'Tag');
robot_set(r, 'RobotModel', model);

end


function onBtnPanelClick(hnd, data)
    
fig = get(get(hnd,'Parent'), 'Parent');
ud  = get(fig,'UserData');
robot_panel(ud.OBJ);

end


end
