     
q1 = -pi/8;  q2 = pi/4;  q3 = pi/4;  q4 = pi/4;

f1 = robot( [dh(pi,0,0,q1); dh(-pi/2,0.015,0,q2); dh(0,0.05,0,q3); dh(0,0.04,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', rp2t(roty(pi/2),[0.04;0.03;-0.015]),...
            'RobotRange', [-pi/2, 0; 0, pi/2; 0, pi/2; 0, pi/2],...
            'RobotGrasper', [0.03; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotCylinderRadius', 0.012,...
            'RobotCylinderApprox', 16);

q1 = 0;  q2 = -pi/16;  q3 = -pi/8;  q4 = -pi/8;

f2 = robot( [dh(pi,0,0,q1); dh(-pi/2,0,0,q2); dh(0,0.05,0,q3); dh(0,0.03,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', [0.1;0.025;0],...
            'RobotRange', [-1/9*pi, 0; -pi/2, 0; -pi/2, 0; -pi/2, 0],...
            'RobotGrasper', [0.025; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotCylinderRadius', 0.01,...
            'RobotCylinderApprox', 16);

f3 = robot( [dh(pi,0,0,q1); dh(-pi/2,0,0,q2); dh(0,0.055,0,q3); dh(0,0.035,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', [0.1;0;0],...
            'RobotRange', [-1/18*pi, 1/18*pi; -pi/2, 0; -pi/2, 0; -pi/2, 0],...
            'RobotGrasper', [0.025; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotCylinderRadius', 0.01,...
            'RobotCylinderApprox', 16);

f4 = robot( [dh(pi,0,0,q1); dh(-pi/2,0,0,q2); dh(0,0.05,0,q3); dh(0,0.03,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', [0.09;-0.02;0],...
            'RobotRange', [0, 1/9*pi; -pi/2, 0; -pi/2, 0; -pi/2, 0],...
            'RobotGrasper', [0.025; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotCylinderRadius', 0.009,...
            'RobotCylinderApprox', 16);

f5 = robot( [dh(pi,0,0,q1); dh(-pi/2,0,0,q2); dh(0,0.04,0,q3); dh(0,0.025,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', [0.08;-0.04;0],...
            'RobotRange', [0, 1/5*pi; -pi/2, 0; -pi/2, 0; -pi/2, 0],...
            'RobotGrasper', [0.023; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotCylinderRadius', 0.008,...
            'RobotCylinderApprox', 16);
        
rhand = robot_complex(f1, f2, f3, f4, f5, ...
                     'RobotBase', [0;0;0], ...   
                     'RobotModel', 'configex', ...
                     'RobotCylinderRadius', 0.01,...
                     'CSysAxisLength', [0 0.1 0 0.1 0 0.1]);


q1 = 0;  q2 = -pi/2;  q3 = 0;  q4 = pi;  q5 = pi/2;  q6 = pi/2;  q7 = pi;

l1 = 0.25;  l2 = 0.25;

rlimb = robot( [dh(0,0,0,q1); dh(pi/2,0,0,q2); dh(pi/2,0,0,q3); dh(0,l1,0,q4); dh(pi/2,0,l2,q5); dh(-pi/2,0,0,q6); dh(pi/2,0,0,q7)], ['r', 'r', 'r', 'r', 'r', 'r', 'r'], ...
              'RobotRange', [-pi/2,pi/2; -pi,-pi/2; -pi/4,pi; pi/2,5*pi/4; -pi/2,pi; pi/4,3*pi/4; 3*pi/4,3*pi/2], ...
              'RobotColor', 'b',...
              'RobotCylinderRadius', 0.02,...
              'RobotCylinderApprox', 16,...
              'CSysAxisLength', 0.1);
          
robot_connect(rlimb, rhand);

% fingers appearance

% b1 = block_move(cuboid(0.03,0.02,0.02),[0.025;0;-0.01]);
% b2 = block_move(prism([[-0.01;-0.01] [0;-0.01] [0.01;0] [0.01;0.01] [-0.01;0.01]], 0.007), [0.05;0;-0.01]);
% b3 = block_move(prism([[-0.01;-0.01] [0;-0.01] [0.01;0] [0.01;0.01] [-0.01;0.01]], 0.007), [0.05;0; 0.003]);
% b4 = block_move(cuboid(0.02,0.01,0.005),[0;0;-0.0025]);
% robot_part(f2,2,block_merge(b1,b2,b3,b4))
% 
% b1 = block_move(cuboid(0.01,0.02,0.02),[0.015;0;-0.01]);
% b2 = block_move(prism([[-0.01;-0.01] [0;-0.01] [0.01;0] [0.01;0.01] [-0.01;0.01]], 0.007), [0.03;0;-0.01]);
% b3 = block_move(prism([[-0.01;-0.01] [0;-0.01] [0.01;0] [0.01;0.01] [-0.01;0.01]], 0.007), [0.03;0; 0.003]);
% b4 = block_move(cuboid(0.02,0.01,0.005),[0;0;-0.0025]);
% robot_part(f2,3,block_merge(b1,b2,b3,b4));
% 
% b1 = block_move(cuboid(0.005,0.02,0.02),[0.0125;0;-0.01]);
% b2 = block_move(prism(arc([0.015;0.01],[0.015;-0.01],0.01), 0.02), [0;0;-0.01]);
% b3 = block_move(cuboid(0.02,0.01,0.005),[0;0;-0.0025]);
% robot_part(f2,4,block_merge(b1,b2,b3));
% robot_panel(f2);


b1 = block_move(cuboid(0.04,0.007,0.007,'BlockColor',[0.85,0.85,0.85]),[0.01;0;-0.0035]);
robot_part(f1,1,b1)

b1 = block_move(cuboid(0.03,0.02,0.02,'BlockColor',[0.85,0.85,0.85]),[0.025;0;-0.01]);
b2 = block_move(prism([[0.01;0.01] [0;0.01] [-0.01;0] [-0.01;-0.01] [0.01;-0.01]], 0.007), [0;0;0.003]);
b3 = block_move(prism([[0.01;0.01] [0;0.01] [-0.01;0] [-0.01;-0.01] [0.01;-0.01]], 0.007), [0;0;-0.01]);
b4 = block_move(prism([[-0.01;-0.01] [0.01;-0.01] [0.01;0] [0;0.01] [-0.01;0.01]], 0.007), [0.05;0;-0.01]);
b5 = block_move(prism([[-0.01;-0.01] [0.01;-0.01] [0.01;0] [0;0.01] [-0.01;0.01]], 0.007), [0.05;0; 0.003]);
robot_part(f1,2,block_merge(b1,b2,b3,b4,b5))

b1 = block_move(cuboid(0.02,0.01,0.005,'BlockColor',[0.85,0.85,0.85]),[0;0;-0.0025]);
b2 = block_move(cuboid(0.02,0.02,0.02),[0.02;0;-0.01]);
b3 = block_move(prism([[-0.01;-0.01] [0.01;-0.01] [0.01;0] [0;0.01] [-0.01;0.01]], 0.007), [0.04;0;-0.01]);
b4 = block_move(prism([[-0.01;-0.01] [0.01;-0.01] [0.01;0] [0;0.01] [-0.01;0.01]], 0.007), [0.04;0; 0.003]);
robot_part(f1,3,block_merge(b1,b2,b3,b4));

b1 = block_move(cuboid(0.02,0.01,0.005,'BlockColor',[0.85,0.85,0.85]),[0;0;-0.0025]);
b2 = block_move(cuboid(0.01,0.02,0.02),[0.015;0;-0.01]);
b3 = block_move(prism(arc([0.02;0.01],[0.02;-0.01],0.01), 0.02), [0;0;-0.01]);
robot_part(f1,4,block_merge(b1,b2,b3));

F = [f2 f3 f4 f5];
L1 = [0.05 0.055 0.05 0.04];
L2 = [0.03 0.035 0.03 0.025];
L3 = [0.025 0.025 0.025 0.023];
R  = [0.01 0.01 0.009 0.008];

for i=1:4
  f = F(i);   l1 = L1(i);  l2 = L2(i);   l3 = L3(i);   r = R(i);
  
  b1 = block_move(cuboid(0.02,r,0.005,'BlockColor',[0.85,0.85,0.85]),[0;0;-0.0025]);
  b2 = block_move(cuboid(l1-0.02,2*r,2*r),[0.01+(l1-0.02)/2;0;-r]);
  b3 = block_move(prism([[-0.01;-r] [0;-r] [0.01;0] [0.01;r] [-0.01;r]], r-0.003), [l1;0;-r]);
  b4 = block_move(prism([[-0.01;-r] [0;-r] [0.01;0] [0.01;r] [-0.01;r]], r-0.003), [l1;0;0.003]);
  robot_part(f, 2, block_merge(b1,b2,b3,b4))

  b1 = block_move(cuboid(0.02,r,0.005,'BlockColor',[0.85,0.85,0.85]),[0;0;-0.0025]);
  b2 = block_move(cuboid(l2-0.02,2*r,2*r),[0.01+(l2-0.02)/2;0;-r]);
  b3 = block_move(prism([[-0.01;-r] [0;-r] [0.01;0] [0.01;r] [-0.01;r]], r-0.003), [l2;0;-r]);
  b4 = block_move(prism([[-0.01;-r] [0;-r] [0.01;0] [0.01;r] [-0.01;r]], r-0.003), [l2;0;0.003]);
  robot_part(f, 3, block_merge(b1,b2,b3,b4));

  b1 = block_move(cuboid(0.02,r,0.005,'BlockColor',[0.85,0.85,0.85]),[0;0;-0.0025]);
  b2 = block_move(cuboid(l3-0.02,2*r,2*r),[0.01+(l3-0.02)/2;0;-r]);
  b3 = block_move(prism(arc([l3-0.01;r],[l3-0.01;-r],r), 2*r), [0;0;-r]);
  robot_part(f, 4, block_merge(b1,b2,b3));
end

% hand appearance

pt = [[0;0.02;0.015] [0.02;0.04;0.015] [0.11;0.04;0.015] [0.11;0.028;0.015] [0.09;0.028;0.015] [0.09;0.022;0.015] [0.11;0.022;0.015] [0.11;0.003;0.015] [0.09;0.003;0.015] [0.09;-0.003;0.015] [0.11;-0.003;0.015] [0.11;-0.01;0.015] [0.1;-0.011;0.015] [0.1;-0.017;0.015] [0.08;-0.017;0.015] [0.08;-0.023;0.015] [0.1;-0.023;0.015] [0.1;-0.029;0.015] [0.09;-0.032;0.015] [0.09;-0.037;0.015] [0.07;-0.037;0.015] [0.07;-0.043;0.015] [0.09;-0.043;0.015] [0.09;-0.05;0.015] [0.02;-0.05;0.015] [0;-0.03;0.015]...
      [0;0.02;-0.015] [0.02;0.04;-0.015] [0.095;0.04;-0.015] [0.095;0.028;-0.015] [0.09;0.028;-0.015] [0.09;0.022;-0.015] [0.095;0.022;-0.015] [0.095;0.003;-0.015] [0.09;0.003;-0.015] [0.09;-0.003;-0.015] [0.095;-0.003;-0.015] [0.095;-0.01;-0.015] [0.085;-0.011;-0.015] [0.085;-0.017;-0.015] [0.08;-0.017;-0.015] [0.08;-0.023;-0.015] [0.085;-0.023;-0.015] [0.085;-0.029;-0.015] [0.075;-0.032;-0.015] [0.075;-0.037;-0.015] [0.07;-0.037;-0.015]  [0.07;-0.043;-0.015]   [0.075;-0.043;-0.015] [0.075;-0.05;-0.015] [0.02;-0.05;-0.015] [0;-0.03;-0.015]...
      [0;0.02;0] [0.02;0.04;0] [0.11;0.04;0] [0.11;0.028;0] [0.09;0.028;0] [0.09;0.022;0] [0.11;0.022;0] [0.11;0.003;0] [0.09;0.003;0] [0.09;-0.003;0] [0.11;-0.003;0] [0.11;-0.01;0] [0.1;-0.011;0] [0.1;-0.017;0] [0.08;-0.017;0] [0.08;-0.023;0] [0.1;-0.023;0] [0.1;-0.029;0] [0.09;-0.032;0] [0.09;-0.037;0] [0.07;-0.037;0] [0.07;-0.043;0] [0.09;-0.043;0] [0.09;-0.05;0] [0.02;-0.05;0] [0;-0.03;0]];
fc = { [1:26; 27:52], ...
       [3 4 56 55; 7 8 60 59; 11 12 64 63; 12 13 65 64; 13 14 66 65; 17 18 70 69; 18 19 71 70; 19 20 72 71; 23 24 76 75; ...\
        29 30 56 55; 33 34 60 59; 37 38 64 63; 38 39 65 64; 39 40 66 65; 43 44 70 69; 44 45 71 70; 45 46 72 71; 49 50 76 75; ...
        5 6 32 31; 9 10 36 35; 15 16 42 41; 21 22 48 47], ...
       [4 5 31 30 56; 7 6 32 33 59; 8 9 35 34 60; 11 10 36 37 63; 14 15 41 40 66; 17 16 42 43 69; 20 21 47 46 72; 23 22 48 49 75; ...
        3 2 28 29 55; 24 25 51 50 76], [1 2 28 27; 1 27 52 26; 25 26 52 51]};
robot_part(rhand, block(pt, fc, 'BlockColor', [0.85, 0.85, 0.85]));

b1 = block_move(prism([[0;0.05] [-0.025;0.025] [-0.025;-0.025] [0;-0.05] [0.21;-0.04] [0.21;0.04]],0.05,'BlockColor',[0.85,0.85,0.85]), [0;0;-0.025]);
b2 = block_move(prism([[-0.04;0.04] [-0.04;-0.04] [0.04;-0.04] [0.04;0] [0;0.04]],0.015), [0.25;0; 0.01]);
b3 = block_move(prism([[-0.04;0.04] [-0.04;-0.04] [0.04;-0.04] [0.04;0] [0;0.04]],0.015), [0.25;0; -0.025]);
robot_part(rlimb,3,block_merge(b1,b2,b3))

% arm appearance

b1 = block_move(cuboid(0.04,0.11,0.02,'BlockColor',[0.85,0.85,0.85]),[0;-0.035;-0.01]);
pt = [[-0.01;-0.04;0.025] [-0.04;-0.04;0.025] [-0.04;-0.04;-0.025] [-0.01;-0.04;-0.025]...
      [0.04;-0.09;-0.025] [0.04;-0.09;0.025]...
      [0.02;-0.21;0.015] [-0.03;-0.21;0.015] [-0.03;-0.21;-0.015] [0.02;-0.21;-0.015]];
pt = [[-0.01;-0.05;0.025] [-0.04;-0.05;0.025] [-0.04;-0.05;-0.025] [-0.01;-0.05;-0.025]...
      [0.04;-0.105;-0.025] [0.04;-0.105;0.025]...
      [0.02;-0.21;0.015] [-0.03;-0.21;0.015] [-0.03;-0.21;-0.015] [0.02;-0.21;-0.015]];
fc = {[1:4; 1 4 5 6; 7:10; 5 10 7 6; 2 3 9 8], [1 2 8 7 6; 4 3 9 10 5]};
b2 = block(pt, fc);
b3 = block_move(cylinder(0.015,0.05), rp2t(rotx(pi/2),[0;-0.21;0]));
robot_part(rlimb, 4, block_merge(b1,b2,b3));

axis([-0.5 0.5 -0.5 0.5 -0.8 0.2]);
% axis([-0.025 0.225 -0.125 0.125 -0.125 0.125]);
csys_plot(csys(eye(4), 'CsysAxisLength', axis))
camlight
view(120,35)

robot_plot(rlimb, 'surf');
robot_plot_csys(rlimb,[0 0 0 1 1 0 0],0)
robot_plot_csys(rhand,1)
robot_panel(rlimb)

q0 = [0; -pi; 0; pi/2; pi/2; pi/2; pi; -pi/8; pi/2; 0; 0; repmat([0;0;0;0],4,1) ];
qt = [0; -pi/2; 0; pi; pi/2; pi/2; pi; 0; pi/8; pi/8; pi/8; repmat([0;-pi/16;-pi/8;-pi/8],4,1) ];

[q, v, a, t, c] = trj_poly3([0,1.25,2,3,5], q0, qt);
f = inline('c''*[t^3; t^2; t; 1]', 'R', 't', 'flag', 'c');
robot_config(rlimb, q0);
pause
% animation(0:0.1:5, rlimb, f, 0.01, 0, c)
robot_motion(rlimb, q, 0, 1)
