
model = 'config';

q1 = -pi/3;  q2 = pi/4;  q3 = pi/4;  q4 = pi/4;

t1 = robot( [dh(pi,0,0,q1); dh(-pi/2,1,0,q2); dh(0,5,0,q3); dh(0,4,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', rp2t(roty(pi/2),[4;3;-1.5]),...
            'RobotRange', [-pi/2, 0; 0, pi/2; 0, pi/2; 0, pi/2],...
            'RobotGrasper', [3; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotColor', 'b',...
            'RobotCylinderRadius', 1,...
            'RobotCylinderApprox', 16,...
            'RobotModel', model,...
            'CSysAxisLength', [0 4 0 4 0 4]);

q1 = 0;  q2 = -pi/16;  q3 = -pi/8;  q4 = -pi/8;

t2 = robot( [dh(pi,0,0,q1); dh(-pi/2,0,0,q2); dh(0,5,0,q3); dh(0,3,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', [9.5;2.2;0],...
            'RobotRange', [-1/9*pi, 0; -pi/2, 0; -pi/2, 0; -pi/2, 0],...
            'RobotGrasper', [2.5; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotColor', 'b',...
            'RobotCylinderRadius', 1,...
            'RobotCylinderApprox', 16,...
            'RobotModel', model,...
            'CSysAxisLength', [0 2 0 2 0 2]);

t3 = robot( [dh(pi,0,0,q1); dh(-pi/2,0,0,q2); dh(0,5.5,0,q3); dh(0,3.5,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', [9.5;0;0],...
            'RobotRange', [-1/18*pi, 1/18*pi; -pi/2, 0; -pi/2, 0; -pi/2, 0],...
            'RobotGrasper', [2.5; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotColor', 'b',...
            'RobotCylinderRadius', 1,...
            'RobotCylinderApprox', 16,...
            'RobotModel', model,...
            'CSysAxisLength', [0 2 0 2 0 2]);

t4 = robot( [dh(pi,0,0,q1+pi/36); dh(-pi/2,0,0,q2); dh(0,5,0,q3); dh(0,3,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', [9;-2;0],...
            'RobotRange', [0, 1/9*pi; -pi/2, 0; -pi/2, 0; -pi/2, 0],...
            'RobotGrasper', [2.5; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotColor', 'b',...
            'RobotCylinderRadius', 0.8,...
            'RobotCylinderApprox', 16,...
            'RobotModel', model,...
            'CSysAxisLength', [0 2 0 2 0 2]);

t5 = robot( [dh(pi,0,0,q1+pi/18); dh(-pi/2,0,0,q2); dh(0,4,0,q3); dh(0,2.5,0,q4)], ['r', 'r', 'r', 'r'],...
            'RobotBase', [8.5;-3.8;0],...
            'RobotRange', [0, 1/5*pi; -pi/2, 0; -pi/2, 0; -pi/2, 0],...
            'RobotGrasper', [2.3; 0; 0],...
            'RobotGrasperSize', 0,...
            'RobotColor', 'b',...
            'RobotCylinderRadius', 0.8,...
            'RobotCylinderApprox', 16,...
            'RobotModel', model,...
            'CSysAxisLength', [0 2 0 2 0 2]);
        
axis([-5 25 -12 12 -12 12]);
csys_plot(csys(eye(4), 'CsysAxisLength', axis))

camlight
rhand = robot_complex(t1, t2, t3, t4, t5, 'RobotBase', [0;0;0], 'RobotModel', 'configex');
robot_plot(rhand, 'surf');
robot_plot_csys(t2, 1);
robot_panel(rhand)
        