
function [B] = blkset(B, name, def, val, init)

if ( strcmp(val,'_undef_') ) val=def; end

switch ( name )
      
  case 'BlockColor'
      
    B.fig.color = val;
    
  case 'BlockEdgeColor'
      
    B.fig.edgeColor = val;
      
  case 'BlockEdgeWidth'
      
    if ( parIsVector(val,1) ) B.fig.edgeWidth=val;
    else rethrow(geterr('propValNum',name)); end

  case 'CSysColor'
    
    B.csys.color = val;
    
  case 'CSysWidth'
    
    if ( parIsVector(val,1) ) B.csys.width=val;
    else rethrow(geterr('propValNum',name)); end
    
  case 'CSysLabelColor'
      
    B.csys.labelColor = val;
    
  case 'CSysLabel'
      
    if ( ischar(val) ) B.csys.label = val;
    else rethrow(geterr('propValTxt',name)); end
    
  case 'CSysAxisLabel'
      
    if ( parIsCellTxt(val, 3) ) B.csys.axisLabel = val;
    else rethrow(geterr('propValCellTxt',name,3)); end
    
  case 'CSysAxisLength'
      
    if ( isnumeric(val) )
      if     ( length(val) == 1 ) val = [0,val,0,val,0,val];
      elseif ( length(val) == 2 ) val = [val(1),val(2),val(1),val(2),val(1),val(2)];
      elseif ( length(val) == 3 ) val = [0,val(1),0,val(2),0,val(3)];
      elseif ( length(val) == 6 ) val = val;
      else rethrow(geterr('propValVect2',name,'2,3,6')); end
      B.csys.axisLength = val;
    else rethrow(geterr('propValVect2',name,'2,3,6')); end
    
end
