
function [CS] = csset(CS, name, def, val, init)

if ( strcmp(val,'_undef_') ) val=def; end

switch ( name )
      
  case 'CSysLabel'
      
    if ( ischar(val) ) CS.label = val;
    else rethrow(geterr('propValTxt',name)); end
    
  case 'CSysAxisLabel'
      
    if ( parIsCellTxt(val, 3) ) CS.axisLabel = val;
    else rethrow(geterr('propValCellTxt',name,3)); end
    
  case 'CSysAxisLength'
      
    if ( isnumeric(val) )
      if     ( length(val) == 1 ) val = [0,abs(val),0,abs(val),0,abs(val)];
      elseif ( length(val) == 2 ) val = [val(1),val(2),val(1),val(2),val(1),val(2)];
      elseif ( length(val) == 3 ) val = [0,abs(val(1)),0,abs(val(2)),0,abs(val(3))];
      elseif ( length(val) == 6 ) val = val;
      else rethrow(geterr('propValVect2',name,'3,6')); end
      CS.axisLength = val;
    else rethrow(geterr('propValVect2',name,'3,6')); end

  case 'CSysColor'
      
    CS.fig.color = val;
    
  case 'CSysWidth'
      
    if ( parIsVector(val,1) ) CS.fig.width = val;
    else rethrow(geterr('propValNum',name)); end
    
    
  case 'CSysLabelColor'
      
    CS.fig.labelColor = val;
    
end
