
function [lst] = optlst(obj)

lst = {};

switch ( obj )
    
   case {'block:basic', 'block:complex' }
       
      lst = { 'BlockColor',     'b',             'col2rgb'
              'BlockEdgeColor', 'none',          'col2rgb'
              'BlockEdgeWidth',  0.5,            ''
              'CSysColor',      'r',             'col2rgb'
              'CSysWidth',       0.5,            ''
              'CSysLabelColor', 'k',             'col2rgb'
              'CSysLabel',      '',              ''
              'CSysAxisLabel',  {'x', 'y', 'z'}, ''
              'CSysAxisLength', [0 1 0 1 0 1],   '' };
      
    case 'csys'
        
      lst = { 'CSysLabel',      '',               ''
              'CSysAxisLabel',  {'x', 'y', 'z'},  ''
              'CSysAxisLength', [-1 1 -1 1 -1 1], ''
              'CSysColor',      'k',              'col2rgb'
              'CSysWidth',       0.5,             ''
              'CSysLabelColor', 'k',              'col2rgb' };
      
    case 'robot:manip'
        
      lst = { 'RobotBase',              eye(4),          ''
              'RobotGrasper',           eye(4),          ''
              'RobotGrasperSize',       [0 0],           ''
              'RobotRange',             [],              ''
              'RobotCylinderRadius',    1,               ''
              'RobotCylinderApprox',    8,               ''
              'RobotModel',             'config',        ''
              'RobotLineWidth',         0.5,             ''
              'RobotColor',             'b',             'col2rgb'
              'RobotLengthColor',       '_undef_',       'col2rgb'
              'RobotOffsetColor',       '_undef_',       'col2rgb'
              'RobotGrasperColor',      '_undef_',       'col2rgb'
              'RobotExColor',           '_undef_',       'col2rgb'
              'RobotEdgeColor',         'none',          'col2rgb'
              'RobotLengthEdgeColor',   '_undef_',       'col2rgb'
              'RobotOffsetEdgeColor',   '_undef_',       'col2rgb'
              'RobotGrasperEdgeColor',  '_undef_',       'col2rgb'
              'RobotExEdgeColor',       '_undef_',       'col2rgb'
              'RobotEdgeWidth',          0.5,            ''
              'CSysColor',              'r',             'col2rgb'
              'CSysWidth',               0.5,            ''
              'CSysLabelColor',         'k',             'col2rgb'
              'CSysAxisLength',         [0 1 0 1 0 1],   ''
              'CSysLabel',              '_undef_',       ''
              'CSysAxisLabel',          {'x', 'y', 'z'}, '' };

    case 'robot:complex'
        
      lst = { 'RobotBase',              eye(4),          ''
              'RobotCylinderRadius',    1,               ''
              'RobotCylinderApprox',    8,               ''
              'RobotModel',             'config',        ''
              'RobotLineWidth',         1,               ''
              'RobotColor',             'b',             'col2rgb'
              'RobotLengthColor',       '_undef_',       'col2rgb'
              'RobotExColor',           '_undef_',       'col2rgb'
              'RobotEdgeColor',         'none',          'col2rgb'
              'RobotLengthEdgeColor',   '_undef_',       'col2rgb'
              'RobotExEdgeColor',       '_undef_',       'col2rgb'
              'RobotEdgeWidth',          0.5,            ''
              'CSysColor',              'r',             'col2rgb'
              'CSysWidth',               0.5,            ''
              'CSysLabelColor',         'k',             'col2rgb'
              'CSysAxisLength',         [0 1 0 1 0 1],   ''
              'CSysLabel',              'C',             ''
              'CSysAxisLabel',          {'x', 'y', 'z'}, '' };

    case 'robot:platform'
        
      lst = { 'RobotBase',              eye(4),          ''
              'RobotRange',             [],              ''
              'RobotPlatformSize',      [5 3 1],         ''
              'RobotLineWidth',         0.5,             ''
              'RobotColor',             'b',             'col2rgb'
              'RobotEdgeColor',         'none',          'col2rgb'
              'RobotEdgeWidth',          0.5,            ''
              'CSysColor',              'r',             'col2rgb'
              'CSysWidth',               0.5,            ''
              'CSysLabelColor',         'k',             'col2rgb'
              'CSysAxisLength',         [0 1 0 1 0 1],   ''
              'CSysLabel',              '_undef_',       ''
              'CSysAxisLabel',          {'x', 'y', 'z'}, '' };

end

for i=1:size(lst,1) lst{i,4}='_undef_'; end
