
function q = rcfgset(R, q)

global RTHND;

switch ( RTHND{R}.ident )
    
  case 'robot:complex'
  
    for i=RTHND{R}.robots
      q = rcfgset(i, q);
      if ( length(q) == 0 ) break; end
    end

    
  case 'robot:manip'

    for i=1:RTHND{R}.n
      if ( i > length(q) ) break; end
      switch ( RTHND{R}.joints(i) )
        case 'r',  RTHND{R}.dh(i,4) = q(i);
        case { 'p', 'd' }
          if ( RTHND{R}.dh(i,3) ~= q(i) )
            RTHND{R}.dh(i,3) = q(i);
            RTHND{R}.plain.lines{i} = rplnarm(RTHND{R}, i, 0);
            if ( RTHND{R}.def3d.conf(i) ) 
              b = rdef3darm(RTHND{R}, i, 2);
              n = RTHND{R}.def3d.cylinderApprox;
              [p, f] = add3dim(dopolygon(b{2,2}, n), b{2,3});
              t = invt(RTHND{RTHND{R}.def3d.blocks(i)}.T);
              p = t * b{2,4} * [p;ones(1,size(p,2))];
              RTHND{RTHND{R}.def3d.conf(i)}.points = p;
            end
          end
      end
    end

    if ( length(q) <= RTHND{R}.n ) q=[];
    else q = q((RTHND{R}.n+1):length(q)); end
    
    if ( RTHND{R}.bond & ( length(q) > 0 ))
      q = rcfgset(RTHND{R}.bond, q);
    end

    if ( RTHND{R}.cblock )
      T = trans2(RTHND{R}.dh, RTHND{R}.base);
      RTHND{RTHND{R}.cblock}.T = T{RTHND{R}.n}*RTHND{R}.grasper*RTHND{R}.tblock;
    end

    if ( RTHND{R}.panel ) rpnl('set', RTHND{R}.panel); end
    
    
  case 'robot:platform'

    for i=1:RTHND{R}.n
      if ( i > length(q) ) break; end
      switch ( RTHND{R}.joints(i) )
        case 'r',          RTHND{R}.dh(i,4) = q(i);
        case { 'p', 'd' }, RTHND{R}.dh(i,3) = q(i);
      end
    end

    if ( length(q) <= RTHND{R}.n ) q=[];
    else q = q((RTHND{R}.n+1):length(q)); end
    
    if ( RTHND{R}.bond & ( length(q) > 0 ))
      q = rcfgset(RTHND{R}.bond, q);
    end

    if ( RTHND{R}.panel ) rpnl('set', RTHND{R}.panel); end
    
end      
