
function [block, len, ex] = rcmplxdef3d(R, h)

global RTHND;

model = R.def3d.model;
if ( strcmpi(model, 'configex') | strcmpi(model, 'rangeex')) mex=1;
else mex=0; end
number = R.def3d.cylinderApprox;
radius = R.def3d.cylinderRadius;
block  = R.def3d.blocks;
len    = R.def3d.length;
ex     = R.def3d.ex;
optlen = {'BlockColor', R.fig.color{1}, 'BlockEdgeColor', R.fig.edgeColor{1}};
optex  = {'BlockColor', R.fig.color{4}, 'BlockEdgeColor', R.fig.edgeColor{4}};

if ( isempty(block) ) block=block_complex(); end

if ( mex & isempty(RTHND{block}.blocks) ) 
  b = sphere(radius*2,[2*number,number],optex{:});
  block_complex(block, b);
  ex = [ex b];
end

for i=h 
  p = RTHND{i}.base(1:3,4);
  if ( norm(p) > 0 )
    rx = rotx(-acos(([0 0 1]*p)/norm(p)));
    rz = rotz(-atan2(p(1),p(2)));
    b = blkmv(cylinder(radius,norm(p),number,optlen{:}), rp2t(rz*rx,[0;0;0]), 0);
    block_complex(block, b);
    len = [len b];
    if ( mex ) 
      b = blkmv(sphere(radius*1.75,[2*number,number],optex{:}), rp2t(eye(3),p), 0);
      block_complex(block, b);
      ex = [ex b];
    end
  end
end

% if ( new )
%   block = block_connect();
%   pos = 2;
%   if ( mex ) 
%     b = sphere(radius*2,[2*number,number],optex{:});
%     block_connect(block, b);
%     ex = [ex b];
%   end
% else pos=1; end
% 
% rp = [];
% for i=h(pos:length(h)) rp=[rp RTHND{i}.base(1:3,4)]; end
% 
% for p=rp, if ( norm(p) > 0 )
%   rx = rotx(-acos(([0 0 1]*p)/norm(p)));
%   rz = rotz(-atan2(p(1),p(2)));
%   b = blkmv(cylinder(radius,norm(p),number,optlen{:}), rp2t(rz*rx,[0;0;0]), 0);
%   block_connect(block, b);
%   len = [len b];
%   if ( mex ) 
%     b = blkmv(sphere(radius*1.75,[2*number,number],optex{:}), rp2t(eye(3),p), 0);
%     block_connect(block, b);
%     ex = [ex b];
%   end
% end, end
