
function [b] = rdef3darm(R, nr, blk)

joint = R.joints(nr);
dh    = R.dh(nr, :);
model = R.def3d.model;
if ( strcmpi(model, 'configex') | strcmpi(model, 'rangeex')) ex=1;
else ex=0; end
radius = R.def3d.cylinderRadius;

b = {0 0 0 []; 0 0 0 []; 0 0 0 []};

if (( ~blk | ( blk == 1 )) & ( dh(2) ~= 0 ))
  len = dh(2);  t = rp2t(roty(pi/2),[0; 0; 0]);
  b{1,1}=1;  b{1,2}=radius;  b{1,3}=len;  b{1,4}=t;
end
    
if (( ~blk | ( blk == 2 )) & (( dh(3) ~= 0 ) | ( joint == 'p' ) | ( joint == 'd' )))
  
  switch( model )

    case {'config', 'configex' }
      if ( joint == 'r' ) 
        len = dh(3);  t = trans1([dh(1:2) 0 dh(4)]);
        if ( ex ) len=len+2*sign(len)*radius;  t=t*rp2t(eye(3),[0;0;-sign(len)*radius]); end
      else
        len = dh(3);  t = trans1([dh(1:2) 0 dh(4)]); 
        if ( ex )  len=len+2*sign(len)*radius;  t=t*rp2t(eye(3),[0;0;-sign(len)*radius]); end
      end
      
    case { 'range', 'rangeex' }
      if ( joint == 'p' ) 
        len = R.range(nr,2)-R.range(nr,1);  
        if ( len < max(abs(R.range(nr,:))) ) len=max(abs(R.range(nr,:))); end
        t = eye(4);
        if ( R.range(nr,2) > 0 ) t=rp2t(eye(3),[0;0;-R.range(nr,2)]);  end
        if ( ex ) len=len+2*radius; t=t*rp2t(eye(3),[0;0;-radius]); end
      elseif ( joint == 'd' )
        len = R.range(nr,2)-R.range(nr,1);
        if ( len < max(abs(R.range(nr,:))) ) len=max(abs(R.range(nr,:))); end
        t = trans1([dh(1:2) 0 dh(4)]);
        if (( R.range(nr,1) < 0 ) & ( R.range(nr,2) < 0 )) t=t*rp2t(eye(3),[0;0;-len]); end
        if (( R.range(nr,1) < 0 ) & ( R.range(nr,2) > 0 )) t=t*rp2t(eye(3),[0;0;R.range(nr,1)]); end
        if ( ex ) len=len+2*radius; t=t*rp2t(eye(3),[0;0;-radius]); end
      elseif ( joint == 'r' )
        len = dh(3);  t = trans1([dh(1:2) 0 dh(4)]);
        if ( ex ) len=len+2*sign(len)*radius;  t=t*rp2t(eye(3),[0;0;-sign(len)*radius]); end
      end
      
  end
  
  if (( len ~= 0 ) | (( strcmpi(model, 'config') | strcmpi(model, 'configex') ) & (( joint == 'p' ) | ( joint == 'd' )))) 
    b{2,1}=1;  b{2,2}=radius;  b{2,3}=len;  b{2,4}=t;
  end
  
end
  
if (( ~blk | ( blk == 3 )) &  ex )
  len = 1.05*radius;
  if (( joint == 'p' ) & ( strcmpi(model, 'range') | strcmpi(model, 'rangeex'))) 
    t = trans1([dh(1:2) -len dh(4)]);
  else t=rp2t(eye(3),[0;0;-len]); end
  b{3,1}=1;  b{3,2}=1.25*radius;  b{3,3}=2*len;  b{3,4}=t;
end
