
function [b] = rdef3dgrasper(R)

model = R.def3d.model;
if ( strcmpi(model, 'configex') | strcmpi(model, 'rangeex')) ex=1;
else ex=0; end
radius = R.def3d.cylinderRadius;

b = {0 0 0 []; 0 0 0 []; 0 0 0 []; 0 0 0 []};

if ( any(R.grasper(1:3,4)) )
  p  = -R.grasper(1:3,1:3)'*R.grasper(1:3,4);
  first = 1;

  if ( abs(p(3)) > 0.0001 )     
    len = p(3);  t = rp2t(eye(3),[p(1:2);0]);
    if ( ex ) len=len+sign(len)*2*radius;  t=t*rp2t(eye(3),[0;0;-sign(len)*radius]); end;
    b{1,1}=1; b{1,2}=radius; b{1,3}=len; b{1,4}=t;
    first = 0;
  end

  if ( abs(p(2)) > 0.0001 ) 
    len = p(2);  t = rp2t(rotx(-pi/2), [p(1);0;0]);
    if ( ex ) len=len+sign(len)*2*radius;  t=t*rp2t(eye(3),[0;0;-sign(len)*radius]); end;
    b{2,1}=1; b{2,2}=radius; b{2,3}=len; b{2,4}=t;
    first = 0;
  end

  if ( abs(p(1)) > 0.0001 ) 
    len = p(1);  t = rp2t(roty(pi/2), [0;0;0]);
    if ( ex & ~first) len=len+sign(len)*radius; end
    b{3,1}=1; b{3,2}=radius; b{3,3}=len; b{3,4}=t;
  end
end

if ( all(R.grasperSize) )
  de1 = R.grasperSize(1);  
  de2 = R.grasperSize(2)/2;
  p = [ [0; de2] [de1/4; de2] [de1; de2/2] [de1/4; de2/2] ...
        [de1/4; -de2/2] [de1; -de2/2] [de1/4;-de2] [0;-de2] ];
  b{4,1}=1; b{4,2}=2*radius; b{4,3}=p; b{4,4}=rp2t(eye(3),[0;0;-radius]);
end;

