
function [T, NR, G] = rfkin(R, base)

global RTHND;

switch ( R.ident )
    
  case 'robot:complex'
  
    T = {};  NR = [];  G = [];  n = 0;
    rbase = base*R.base;
    for i=R.robots
      [t, nr, g] = rfkin(RTHND{i}, rbase);
      T  = { T{:}, t{:} };
      NR = [ NR, nr+n ];
      G  = [ G, g ];
      n  = n+max(nr);
    end
    
  case 'robot:manip'
      
    T = trans2(R.dh, base*R.base);
    if ( R.bond ) 
      [t, nr, g] = rfkin(RTHND{R.bond}, T{end});
      T = { T{:}, t{:} };
      NR = nr+R.n;
      G  = g;
    else
      NR = R.n;
      G  = R.grasper(1:3,4);
    end

  case 'robot:platform'
      
    T = trans2(R.dh, base*R.base*R.T);
    if ( R.bond ) 
      [t, nr, g] = rfkin(RTHND{R.bond}, T{end});
      T = { T{:}, t{:} };
      NR = nr+R.n;
      G  = g;
    else
      NR = R.n;
      G  = [0;0;0];
    end

end

end
