
function [val] = rget(R, name)

global RTHND;

switch ( name )
      
  case 'RobotBase',        val = RTHND{R}.base;
  case 'RobotGrasper',     val = RTHND{R}.grasper;
  case 'RobotGrasperSize', val = RTHND{R}.grasperSize;
  case 'RobotRange',       val = RTHND{R}.range;

  case 'RobotLineWidth',   val = RTHND{R}.plain.lineWidth;
  case 'RobotColor',     
    val = RTHND{R}.fig.color;
    switch ( RTHND{R}.ident )
      case 'robot:manip'
        if ( all(val{1}==val{2}) & all(val{1}==val{3}) & all(val{1}==val{4}) ) val=val{1}; end
      case 'robot:complex'
        if ( all(val{1}==val{4}) ) val=val{1}; 
        else val={val{1},val{4}}; end
    end
  case 'RobotLengthColor',   val = RTHND{R}.fig.color{1};
  case 'RobotOffsetColor',   val = RTHND{R}.fig.color{2};
  case 'RobotGrasperColor',  val = RTHND{R}.fig.color{3};
  case 'RobotExColor',       val = RTHND{R}.fig.color{4};
  case 'RobotEdgeColor',
    val = RTHND{R}.fig.edgeColor;
    switch ( RTHND{R}.ident )
      case 'robot:manip'
        if ( all(val{1}==val{2}) & all(val{1}==val{3}) & all(val{1}==val{4}) ) val=val{1}; end
      case 'robot:complex'
        if ( all(val{1}==val{4}) ) val=val{1}; 
        else val={val{1},val{4}}; end
    end
  case 'RobotLengthEdgeColor',   val = RTHND{R}.fig.edgeColor{1};
  case 'RobotOffsetEdgeColor',   val = RTHND{R}.fig.edgeColor{2};
  case 'RobotGrasperEdgeColor',  val = RTHND{R}.fig.edgeColor{3};
  case 'RobotExEdgeColor',       val = RTHND{R}.fig.edgeColor{4};
  case 'RobotEdgeWidth',         val = RTHND{R}.fig.edgeWidth;
      
  case 'RobotCylinderRadius', val = RTHND{R}.def3d.cylinderRadius;
  case 'RobotCylinderApprox', val = RTHND{R}.def3d.cylinderApprox;
  case 'RobotModel',          val = RTHND{R}.def3d.model;
      
  case 'CSysAxisLength', val = RTHND{R}.csys.axisLength ;
  case 'CSysColor',      val = RTHND{R}.csys.color;
  case 'CSysWidth',      val = RTHND{R}.csys.width;
  case 'CSysLabelColor', val = RTHND{R}.csys.labelColor;
  case 'CSysLabel',      val = RTHND{R}.csys.label;
  case 'CSysAxisLabel',  val = RTHND{R}.csys.axisLabel;
      
end
