
function rinfo(R, full)

global RTHND;

r = RTHND{R};
disp(sprintf(' '));
disp(sprintf('   Handle: [%d]', r.hnd));
disp(sprintf('   Class : %s', r.ident));
if ( r.owner ~= 0 ) disp(sprintf('   Owner : %s [%d]', RTHND{r.owner}.ident, r.owner)); end

disp(sprintf(' '));
switch ( r.ident ) 
  case 'robot:manip'
    disp(sprintf('   Joints: %s', r.joints));
    disp(sprintf('   DH    :'));
    s='     '; for i=1:size(r.dh,2) s=[s, '%5.2f   ']; end
    for i=1:size(r.dh,1) disp(sprintf(s, r.dh(i,:)));  end
    if ( r.bond ) disp(sprintf('   Connected mechanism: [%d]', r.bond)); end
  case 'robot:complex'
    s='   Robots:'; for i=1:length(r.robots) s=[s, ' [%d]']; end
    disp(sprintf(s, r.robots));
end

disp(sprintf(' '));
if ( ~isempty(find(r.user3d.blocks)) )
  disp(sprintf('   User 3D view:'));
  s = '';  for i=2:r.n+1 
    if ( r.user3d.blocks(i) ) s=[s, sprintf(' [%d]',r.user3d.blocks(i))]; 
    else s=[s, ' undefined']; end
  end
  disp(sprintf('      Arms   :%s', s));
  if ( r.user3d.blocks(1)     ) s=sprintf('[%d]', r.user3d.blocks(1));     else s='undefined'; end
  disp(sprintf('      Base   : %s', s));
  if ( r.user3d.blocks(r.n+2) ) s=sprintf('[%d]', r.user3d.blocks(r.n+2)); else s='undefined'; end
  disp(sprintf('      Grasper: %s', s));
else disp(sprintf('   User 3D view: not defined')); end

disp(sprintf(' '));
o = RTHND{getowner(R, 'hnd')};
if ( o.fig.view ~= -1 ) 
  p = o.fig.axes;
  while ( 1 ) if ( get(p,'Parent') > 0 ) p=get(p,'Parent'); else break; end; end
  disp(sprintf('   Plot : %s, figure [%d]', num2view(o.fig.view), p));
  if ( any(r.csys.view) ) switch ( r.ident ) 
    case 'robot:manip'
      s = '';  cs = find(r.csys.view(2:r.n+1));
      if ( ~isempty(cs) ) for i=1:length(cs) s=[s, sprintf(' %d',cs(i))]; end; end
      if ( r.csys.view(1)     ) if ( length(s) > 0 ) s=[s, ',']; end;  s=[s, ' base'];    end
      if ( r.csys.view(r.n+2) ) if ( length(s) > 0 ) s=[s, ',']; end;  s=[s, ' grasper']; end
      disp(sprintf('   CSys :%s', s));
    case 'robot:complex'
      disp(sprintf('   CSys : visible')); 
    end 
  else disp(sprintf('   CSys : not visible')); end
else disp(sprintf('   Plot : not plotted')); end
if ( o.panel > 0 ) 
  p = o.panel;
  while ( 1 ) if ( get(p,'Parent') > 0 ) p=get(p,'Parent'); else break; end; end
  disp(sprintf('   Panel: figure [%d]', p)); 
else disp(sprintf('   Panel: not visible')); end
disp(sprintf(' '));

if ( ~full ) return; end

disp(sprintf('   Properties:\n   -----------\n'));
propinfo(R, @rget);
disp(sprintf(' '));
