
function [R]=rmnpcreate(hnd, dh, joints, lst)

global RTHND;

R.hnd   = hnd;           % uchwyt obiektu
R.ident = 'robot:manip'; % identyfikator obiektu
R.owner = 0;             % waciciel obiektu
R.index = 0;             % indeks manipulatora w robocie zoonym

R.dh     = dh;            % parametry DH
R.n      = size(dh, 1);   % liczba par kinem,atycznych
R.joints = joints;        % typy pocze ('r', 'p', 'd')

% ustawienie wartoci opcji
for i=1:size(lst,1) R=rset(R, lst{i,1}, lst{i,2}, lst{i,4}, 1); end
               
R.fig.view      = -1;       % metoda uyta do narysowania robota
R.fig.axes      = -1;       % uchwyt obszaru rysunku (axes) w oknie
R.fig.handle    = [];       % uchwyty obiektw tworzcych rysunek robota
R.panel         = 0;        % uchwyt okna panelu     

R.plain.lines = rplain(R);  % tablica odcinkw tworzacych widok schematyczny

R.def3d.blocks = uint32([]); % tablica uchwytw bry tworzcych domylny widok 3D
R.def3d.conf   = [];         % tablica uchwytw bry odsuni w modelu config(ex)
R.def3d.length = [];         % tablica uchwytw bry tworzcych dugoci
R.def3d.offset = [];         % tablica uchwytw bry tworzcych odsunicia
R.def3d.ex     = [];         % tablica uchwytw bry tworzcych dodatkowe elementy (w modelu ex)
for i=1:R.n+2 
  R.def3d.blocks(i) = block_complex(); 
  RTHND{R.def3d.blocks(i)}.owner = hnd; 
end
R = rrfrsh(R, 'RobotModel');
R = rrfrsh(R, 'RobotGrasper');

R.user3d.blocks = uint32(zeros(1,R.n+2)); % tablica uchwytw bry tworzcych widok 3D uytkownika

R.csys.view   = zeros(1,R.n+2);   % widoczno ukadw wsprzdnych poszczeglnych czonw
R.csys.handle = [];               % uchwyty obiektw tworzcych rysunek ukadw wsprzednych

R.bond   = 0;  % uchwyt doaczonego robota typu robot:complex

R.cblock = 0;  % brya chwycona przez robota
R.tblock = []; % macierz przeksztacenia ukadu bryy w ukadzie efektora
