
function [R] = rplt(R, base, axs, view)

global RTHND;
r = RTHND{R};

if ( view ~= -1 )

v = view;

switch view
  case { 1, 2 }
    if ( ~any(r.user3d.blocks) ) blk=r.def3d.blocks;
    else blk=r.user3d.blocks; end
  case 3
    blk = r.def3d.blocks;
    v = 1;
  case 4
    if ( ~any(r.user3d.blocks) ) error('Niezdefiniowany wyglad 3D'); end
    blk = r.user3d.blocks;
    v = 1;
  case 5
    blk = r.def3d.blocks;
    v = 2;
  case 6
    if ( ~any(r.user3d.blocks) ) error('Niezdefiniowany wyglad 3D'); end
    blk = r.user3d.blocks;
    v = 2;
end


switch ( r.ident )
    
  case 'robot:complex'
    
    base = base*r.base;

    switch ( v )
        
      case 0, if ( ~isempty(r.plain.lines) )
        p = base*r.plain.lines;    
        r.fig.handle = [r.fig.handle, plot3(p(1,:), p(2,:), p(3,:),...
          'Color', r.fig.color{1}, 'LineWidth', r.plain.lineWidth, 'Parent', axs)];
      end  
          
      case { 1, 2 }, if ( ~isempty(blk) )
        t = RTHND{blk}.T;
        blkplt(blkmv(blk, base, 1), axs, v); 
        RTHND{blk}.T = t;
      end
      
    end
    
    for i=r.robots rplt(i, base, axs, view); end
    
  case 'robot:manip'
    
    base = base*r.base;
    T = trans2(r.dh, base);
    T = { base, T{:}, T{r.n}*r.grasper };
    
    switch ( v )
        
      case 0           
        for i=1:r.n+1, if ( ~isempty(r.plain.lines{i}) ) 
          p = T{i}*r.plain.lines{i};
          r.fig.handle = [r.fig.handle, plot3(p(1,1:2), p(2,1:2), p(3,1:2),... 
           'Color', r.fig.color{1}, 'LineWidth', r.plain.lineWidth, 'Parent', axs)];
          r.fig.handle = [r.fig.handle, plot3(p(1,2:3), p(2,2:3), p(3,2:3),... 
           'Color', r.fig.color{2}, 'LineWidth', r.plain.lineWidth, 'Parent', axs)];
        end; end
        if ( ~isempty(r.plain.lines{r.n+2}) ) 
          p = T{r.n+2}*r.plain.lines{r.n+2};
          r.fig.handle = [r.fig.handle, plot3(p(1,:), p(2,:), p(3,:),... 
           'Color', r.fig.color{3}, 'LineWidth', r.plain.lineWidth, 'Parent', axs)];
        end

      case { 1, 2 }, for i=find(blk)
        b = blk(i);  
        t = RTHND{b}.T;
        blkplt(blkmv(b,T{i},1), axs, v); 
        RTHND{b}.T = t;
      end

    end

    if ( r.bond ) rplt(r.bond, T{r.n+1}, axs, view); end

  case 'robot:platform'
    
    base = base*r.base*r.T;
    T = trans2(r.dh, base);
    
    switch ( v )
        
      case 0           
        if ( ~isempty(r.plain.lines) ) 
          p = T{3}*r.plain.lines;
          r.fig.handle = [r.fig.handle, plot3(p(1,:), p(2,:), p(3,:),... 
           'Color', r.fig.color{1}, 'LineWidth', r.plain.lineWidth, 'Parent', axs)];
        end;

      case { 1, 2 }
        t = RTHND{blk}.T;
        blkplt(blkmv(blk,T{3},1), axs, v); 
        RTHND{blk}.T = t;

    end

    if ( r.bond ) rplt(r.bond, T{3}, axs, view); end
    
end

r.fig.view = view;

RTHND{R} = r;

end

if ( any(r.csys.view) ) rpltcsys(R, axs, r.csys.view); end
