
function [R] = rpltcsys(R, axs, nr)

global RTHND;
r = RTHND{R};

switch( RTHND{R}.ident )
    
  case 'robot:complex'
      
    if ( nr )
      base = getbase(R)*r.base;
      r.csys.handle = [r.csys.handle, csplt(axs, base,... 
                       r.csys.axisLength, r.csys.label, r.csys.axisLabels,... 
                       r.csys.color, r.csys.labelColor, r.csys.width)];
      r.csys.view(1) = 1;
    end
      
  case 'robot:manip'
      
    base = getbase(R) * r.base;
    T = trans2(r.dh, base);
    T = { base, T{:}, T{r.n}*r.grasper };
    for i=1:r.n+2 if ( nr(i) )
      r.csys.handle = [r.csys.handle, csplt(axs, T{i},... 
                       r.csys.axisLength, r.csys.label{i}, r.csys.axisLabels(i, :),... 
                       r.csys.color, r.csys.labelColor, r.csys.width)];
    end; end
    r.csys.view = nr;
      
  case 'robot:platform'
      
    base = getbase(R)*r.base*r.T;
    T = trans2(r.dh, base);
    T = { base, T{3} };
    for i=1:2 
      if ( nr(i) )
        r.csys.handle = [r.csys.handle, csplt(axs, T{i},... 
                         r.csys.axisLength, r.csys.label{i}, r.csys.axisLabels(i, :),... 
                         r.csys.color, r.csys.labelColor, r.csys.width)];
      end
    end
    r.csys.view = nr;
      
end

RTHND{R} = r;
