
function rpnl(act, par1, par2)

global RTHND;

switch ( act )
    
  case 'init'
   
    R   = par1;
    fig = par2;
    r   = RTHND{R};
    RTHND{R}.panel = fig;
    
    ud.R    = R;
    ud.type = 'panel';
  
    % inicjalizacja okna
    set(fig, 'Units', 'pixels', 'MenuBar', 'none', 'Resize', 'off',...
             'NumberTitle','off','Name', sprintf('Robot panel [%d]',R),...
             'DeleteFcn', {@ondelete, fig});
    %'ResizeFcn', {@onresize, fig},         

    % obliczenie rozmiarw panelu
    fs = get(uicontrol(fig, 'Style', 'text', 'FontUnits', 'pixels', 'Visible', 'off', 'String', ''), 'FontSize');
    par.wtext1  = 2*fs;    par.wtext2  = 3*fs;    par.htext  = 1.25*fs;
    par.wslider = 15*fs;   par.hslider = 1.75*fs;  
    par.wspace  = 0.5*fs;  par.hspace  = 0.6*fs;  par.border = 0.75*fs;
    size = [2*par.border, 2.25*par.border] + getpnlsize(r,3,par);
%     switch ( r.ident ) 
%       case 'robot:manip', size=size+getsize(r, 3, par);
%       case 'robot:complex'
%         size(1) = size(1)+getsize(RTHND{r.robots(1)}, 1, par);
%         for i=r.robots size(2)=size(2)+getsize(RTHND{i},2,par); end
%         size(2) = size(2)+(length(r.robots)-1)*par.border;
%     end
    ud.size = size;
    set(fig,'UserData', ud);
    
    % ustalenie pozycji i rozmiarw okna
    scr = get(0,'ScreenSize'); 
    p = [round((scr(3)-size(1)-50)*rand(1)), round((scr(4)-size(2)-50)*rand(1)), size(1), size(2)];
    if ( r.fig.axes ~= -1 )
      aud = get(r.fig.axes,'UserData');
      nr = 0;
      for i=aud.obj_hnd
        if ( strfind(RTHND{i}.ident,'robot') & RTHND{i}.panel ) nr=nr+1; end
      end
      u1 = get(r.fig.axes,'Units'); set(r.fig.axes,'Units','pixels');
      h = getfig(r.fig.axes);
      u2 = get(h, 'Units');    set(h, 'Units', 'pixels');
      p1 = get(h, 'Position');
      p2 = get(r.fig.axes,'OuterPosition');
      set(r.fig.axes, 'Units', u1);   set(h, 'Units', u2);
      p(1:2) = [p1(1)-0.75*size(1)+nr*2*fs, p1(2)+p2(4)-1.25*size(2)-nr*2*fs];
    end
    
    if ( p(1) < 0              ) p(1)=0; end
    if ( p(1)+size(1) > scr(3) ) p(1)=scr(3)-size(1); end
    if ( p(2) < 0              ) p(2)=0; end
    set(fig, 'Position', p);
    
    inscontrols(r, fig, par.border, size(2)-par.border, par);

    % konstrukcja panelu
%     x = par.border;  
%     switch ( r.ident ) 
%       case 'robot:manip', insgrp(r, fig, x, 2*par.border, par);
%       case 'robot:complex'
%         y = size(2)-2*par.border;
%         for i=r.robots 
%           y = y - getgrpsize(RTHND{i}, 2, par);
%           s = insgrp(RTHND{i}, fig, x , y, par); 
%           y = y - par.border;
%         end
%     end
  
    
  case 'set'
        
    grp = par1;  
    ud = get(grp,'UserData');

    v = rcfgget(ud.R,1);
    for i=1:RTHND{ud.R}.n
      set(ud.sld(i), 'Value', v(i));
      set(ud.val(i),'String', sprintf('%4.2f',v(i)));
    end

end




% function [size] = getsize(r, dim, par)
% 
% size = [par.wtext1+par.wslider+par.wtext2+par.border+2*par.wspace;...
%         r.n*par.hslider+(r.n-1)*par.hspace+4*par.border]; 
% if ( dim ~= 3 ) size=size(dim); end




function [size] = getgrpsize(r, dim, par)

if (( dim == 1 ) | ( dim == 3 ))
  s1 = par.wtext1+par.wslider+par.wtext2+par.border+2*par.wspace;
end
if (( dim == 2 ) | ( dim == 3 ))
  s2 = r.n*par.hslider+(r.n-1)*par.hspace+4*par.border; 
end

switch ( dim ) 
  case 1, size=s1;
  case 2, size=s2;
  case 3, size=[s1 s2];
end        




function [size] = getpnlsize(r, dim, par)

global RTHND;

size = [0 0];

switch ( r.ident ) 
    
  case 'robot:complex'
    size(1) = getgrpsize(r, 1, par);
    for i=r.robots size(2)=size(2)+getpnlsize(RTHND{i},2,par); end
    size(2) = size(2)+(length(r.robots)-1)*par.border;
    
  case { 'robot:manip', 'robot:platform' }
    size = getgrpsize(r, 3, par);
    if ( r.bond ) size(2)=size(2)+par.border+getpnlsize(RTHND{r.bond},2,par); end
      
end

if ( dim ~= 3 ) size=size(dim); end
               



function insgrp(r, fig, x, y, par)

global RTHND;

ud.R = r.hnd;
  
% zakresy pocze, domylnie (r: -pi..pi, p,d: 0..10)
for i=1:r.n
  if ( r.range(i,1) == -Inf ) 
    if ( r.joints(i) == 'r' ) r.range(i,1)=-pi; 
    else  r.range(i,1)=-10; end
  end
  if ( r.range(i,2) == Inf ) 
    if ( r.joints(i) == 'r' ) r.range(i,2)=pi; 
    else  r.range(i,2)=10; end
  end

  if ( r.joints(i) == 'r' ) v=r.dh(i,4); else  v=r.dh(i,3); end
  if ( v < r.range(i,1) ) r.range(i,1)=v; end
  if ( v > r.range(i,2) ) r.range(i,2)=v; end
end
    
% utworzenie kontrolek
bc   = get(fig,'Color');
size = getgrpsize(r,3,par); 
grp  = uibuttongroup('Parent', fig, 'Title', sprintf('[%d]',r.hnd),... 
  'Units', 'pixels', 'BackgroundColor', bc, 'Position', [x,y,size]);
set(grp, 'DeleteFcn', {@ondelete, grp});
RTHND{r.hnd}.panel = grp;

y = size(2)-2.5*par.border-par.hslider;
for i=1:r.n
  min = r.range(i,1); max = r.range(i,2); 
  if ( r.joints(i) == 'r' ) v=r.dh(i,4); else  v=r.dh(i,3); end

  x = 0.5*par.border;
  if ( r.joints(i) == 'r' )
    ud.lbl(i)=uicontrol(grp, 'Style', 'text', 'Units', 'pixels', ...
      'HorizontalAlignment', 'right', 'FontName', 'Symbol', 'BackgroundColor', bc, ...
      'Position',[x y+(par.hslider-par.htext)/2 par.wtext1 par.htext], 'String', sprintf('q%d:',i));
  else
    ud.lbl(i)=uicontrol(grp, 'Style', 'text', 'Units', 'pixels', ...
      'HorizontalAlignment', 'right', 'BackgroundColor', bc, ... 
      'Position',[par.border y+(par.hslider-par.htext)/2 par.wtext1 par.htext], 'String', sprintf('d%d:',i));
  end
      
  x = x + par.wtext1+par.wspace;
  ud.sld(i) = uicontrol(grp, 'Style', 'slider', 'Units','pixels', ...
    'Min', min, 'Max', max, 'Value', v, 'SliderStep', [0.01 0.1], ...
    'Position',[x y par.wslider par.hslider], 'CallBack', {@onchange, grp});
       
  x = size(1)-par.border-par.wtext2;
  ud.val(i) = uicontrol(grp, 'Style', 'text', 'Units','pixels', ...
    'HorizontalAlignment', 'left', 'BackgroundColor', bc, ...
    'Position',[x y+(par.hslider-par.htext)/2 par.wtext2 par.htext], 'String', sprintf('%4.2f',v));
    
  y = y-par.hslider-par.hspace;
end
    
set(grp,'UserData', ud);




% function inscontrols(r, fig, size, par)
% 
% global RTHND;
% 
% x = par.border;  
% 
% switch ( r.ident ) 
%   case 'robot:manip'
%     insgrp(r, fig, x, 2*par.border, par);
%   case 'robot:complex'
%     y = size(2)-2*par.border;
%     for i=r.robots 
%       y = y - getgrpsize(RTHND{i}, 2, par);
%       s = insgrp(RTHND{i}, fig, x , y, par); 
%       y = y - par.border;
%     end
% end

function [y] = inscontrols(r, fig, x, y, par)

global RTHND;

switch ( r.ident ) 

  case 'robot:complex'
    for i=r.robots y=inscontrols(RTHND{i}, fig, x , y, par); end
    
  case { 'robot:manip', 'robot:platform' }
    y = y - getgrpsize(r, 2, par);
    insgrp(r, fig, x, y, par);
    y = y - par.border;
    if ( r.bond ) y=inscontrols(RTHND{r.bond}, fig, x , y, par); end
end



  
function onchange(hnd, data, grp)

global RTHND;
        
ud = get(grp,'UserData');

v = zeros(RTHND{ud.R}.n,1);
for i=1:RTHND{ud.R}.n v(i)=get(ud.sld(i),'Value'); end
  
rcfgset(ud.R, v);

axs = getowner(ud.R, 'axes');
if ( axs ~= -1 ) 
  hold(axs, 'on'); 
  rrdrw(ud.R, axs, 1); 
  hold(axs, 'off'); 
end




% function onresize(hnd, data, fig)
% 
% global RTHND;
% 
% ud = get(fig,'UserData');
%       
% p = get(fig, 'Position');
% set(fig, 'Position', [p(1), p(2), ud.size(1), ud.size(2)]); 
    
    


function ondelete(hnd, data, grp)

global RTHND;
        
ud = get(grp,'UserData');
RTHND{ud.R}.panel = 0;
