
function [R]=rrfrsh(R, par)

global RTHND;

switch ( par )
      
  case { 'RobotGrasper', 'RobotGrasperSize' }
      
    R.plain.lines = rplain(R); 
      
    number = R.def3d.cylinderApprox;
    optgrp = {'BlockColor', R.fig.color{3}, 'BlockEdgeColor', R.fig.edgeColor{3}};
    blk = rdef3dgrasper(R);  b = []; 
    if ( blk{1,1} ) b=[b blkmv(cylinder(blk{1,2},blk{1,3},number,optgrp{:}),blk{1,4},0)]; end
    if ( blk{2,1} ) b=[b blkmv(cylinder(blk{2,2},blk{2,3},number,optgrp{:}),blk{2,4},0)]; end
    if ( blk{3,1} ) b=[b blkmv(cylinder(blk{3,2},blk{3,3},number,optgrp{:}),blk{3,4},0)]; end
    if ( blk{4,1} ) b=[b blkmv(prism(blk{4,3},blk{4,2},optgrp{:}),blk{4,4},0)]; end
    
    for i=RTHND{R.def3d.blocks(R.n+2)}.blocks RTHND{i}=0; end;
    RTHND{R.def3d.blocks(R.n+2)}.blocks = [];
    RTHND{R.def3d.blocks(R.n+2)}.T      = eye(4);

    if ( length(b) )
      b = num2cell(b);
      RTHND{R.def3d.blocks(R.n+2)} = blkcmplxattach(RTHND{R.def3d.blocks(R.n+2)}, b{:});
    end
    

  case { 'RobotColor', 'RobotLengthColor', 'RobotOffsetColor', 'RobotGrasperColor', 'RobotExColor' }
    
    for b=R.def3d.length RTHND{b}.fig.color = R.fig.color{1}; end
    for b=R.def3d.ex     RTHND{b}.fig.color = R.fig.color{4}; end

    switch( R.ident )
      case 'robot:manip'
        for b=R.def3d.offset RTHND{b}.fig.color = R.fig.color{2}; end
        if ( R.def3d.blocks(R.n+2) )
          for b=RTHND{R.def3d.blocks(R.n+2)}.blocks RTHND{b}.fig.color = R.fig.color{3}; end
        end
      case 'robot:complex'
        b = R.def3d.link;
        if ( b ) RTHND{b}.fig.color = R.fig.color{1}; end
    end
    
    
  case { 'RobotEdgeColor', 'RobotLengthEdgeColor', 'RobotOffsetEdgeColor', 'RobotGrasperEdgeColor', 'RobotExEdgeColor' }
      
    for b=R.def3d.length RTHND{b}.fig.edgeColor = R.fig.edgeColor{1}; end
    for b=R.def3d.ex     RTHND{b}.fig.edgeColor = R.fig.edgeColor{4}; end

    switch( R.ident )
      case 'robot:manip'
        for b=R.def3d.offset RTHND{b}.fig.edgeColor = R.fig.edgeColor{2}; end
        if ( R.def3d.blocks(R.n+2) )
          for b=RTHND{R.def3d.blocks(R.n+2)}.blocks RTHND{b}.fig.edgeColor = R.fig.edgeColor{3}; end
        end
      case 'robot:complex'
        b = R.def3d.link;
        if ( b ) RTHND{b}.fig.edgeColor = R.fig.edgeColor{1}; end
    end
    

  case 'RobotEdgeWidth'
      
    for blk=find(R.def3d.blocks)
      for b=RTHND{R.def3d.blocks(blk)}.blocks RTHND{b}.fig.edgeWidth = R.fig.edgeWidth; end
    end
  

  case 'RobotRange'
      
    R = rrfrsh(R, 'RobotModel');

    
  case { 'RobotCylinderRadius', 'RobotCylinderApprox' }
      
    R = rrfrsh(R, 'RobotModel');

    switch( R.ident )
      case 'robot:manip', R=rrfrsh(R, 'RobotGrasper');
    end

    
  case 'RobotModel'
      
    switch( R.ident )
        
      case 'robot:manip'
    
        number = R.def3d.cylinderApprox;
        optlen = {'BlockColor', R.fig.color{1}, 'BlockEdgeColor', R.fig.edgeColor{1}};
        optoff = {'BlockColor', R.fig.color{2}, 'BlockEdgeColor', R.fig.edgeColor{2}};
        optex  = {'BlockColor', R.fig.color{4}, 'BlockEdgeColor', R.fig.edgeColor{4}};
        optgrp = {'BlockColor', R.fig.color{3}, 'BlockEdgeColor', R.fig.edgeColor{3}};

        blocks = zeros(1,R.n+2);
        conf   = zeros(1,R.n);
        len    = [];
        off    = [];
        ex     = [];

        for i=1:R.n+1 b{i}=[]; end

        for i=1:R.n 
          b1=0; b2=0; b3=0;
          blk = rdef3darm(R, i, 0); 
          if ( blk{1,1} ) b1=blkmv(cylinder(blk{1,2},blk{1,3},number,optlen{:}),blk{1,4},0); len=[len b1]; end
          if ( blk{2,1} ) b2=blkmv(cylinder(blk{2,2},blk{2,3},number,optoff{:}),blk{2,4},0); off=[off b2]; end
          if ( blk{3,1} ) b3=blkmv(cylinder(blk{3,2},blk{3,3},number,optex{:}), blk{3,4},0); ex =[ex b3];  end
          b{i} = [b{i} b1];
          switch ( R.def3d.model )
            case { 'range', 'rangeex' }
              switch ( R.joints(i) )
                case 'p'
                  b{i+1} = [b{i+1} b2];  
                  b{i}   = [b{i} b3];
                case { 'd', 'r' }
                  b{i}   = [b{i} b2];  
                  b{i+1} = [b{i+1} b3];
              end
            case { 'config', 'configex' }
              b{i}   = [b{i} b2];  
              b{i+1} = [b{i+1} b3];
              if ( R.joints(i) ~= 'r' ) conf(i)=b2; end
          end
        end

        for i=1:R.n+1
          for j=RTHND{R.def3d.blocks(i)}.blocks RTHND{j}=0; end;
          RTHND{R.def3d.blocks(i)}.blocks = [];
          RTHND{R.def3d.blocks(i)}.T      = eye(4);
        end

        for i=1:R.n+1
          [p1,p2,v] = find(b{i});
          if ( length(v) )
            v = num2cell(v);
            RTHND{R.def3d.blocks(i)} = blkcmplxattach(RTHND{R.def3d.blocks(i)}, v{:});
          end
        end
    
        R.def3d.conf   = conf;
        R.def3d.length = len;
        R.def3d.offset = off;
        R.def3d.ex     = ex;
    
      case 'robot:complex'
          
        R.plain.lines = rcmplxplain(R);
        if ( R.owner )
          p = tinv(R.base);  p = p(1:3,4);
          if ( norm(p) > 0 )
            R.plain.lines = [R.plain.lines [0;0;0;1] [p;1]];
          end
        end
          
        for i=RTHND{R.def3d.blocks}.blocks RTHND{i}=0; end;
        RTHND{R.def3d.blocks}.blocks = [];
        [R.def3d.blocks, R.def3d.length, R.def3d.ex] = rcmplxdef3d(R, R.robots);
        
        blk = rcmplxdef3dlnk(R);
        if ( blk{1} )
          b = cylinder(blk{2}, blk{3}, R.def3d.cylinderApprox,...
              'BlockColor', R.fig.color{1}, 'BlockEdgeColor', R.fig.edgeColor{1});
          bc = R.def3d.blocks;
          RTHND{bc} = blkcmplxattach(RTHND{bc},blkmv(b, blk{4}, 0)); 
          R.def3d.link = b;
        end

  end
    
    
  case 'RobotPlatformSize'
      
    switch( R.ident )
        
      case 'robot:platform'
          
        R.plain.lines = rpltfrmplain(R);
        
        for i=RTHND{R.def3d.blocks}.blocks RTHND{i}=0; end;
        RTHND{R.def3d.blocks}.blocks = [];
        
        b = cuboid(R.platformSize(1), R.platformSize(2), R.platformSize(3),...
            'BlockColor', R.fig.color{1}, 'BlockEdgeColor', R.fig.edgeColor{1});
        bc = R.def3d.blocks;
        RTHND{bc} = blkcmplxattach(RTHND{bc}, b); 
        
    end
    
end
