
function [grp, height, ctrl] = uigrp(parent, title, width, varargin)

ctrls = {};  hctrls = [];
nr = 0;  j = 0;  
for i=1:length(varargin)
  if ( ischar(varargin{i}) & strcmpi(varargin{i},'style') ) 
    nr = nr+1;  j=1; 
    switch ( varargin{i+1} ) 
      case 'checkbox',     hctrls(nr) = 1;
      case 'radiobutton',  hctrls(nr) = 1;
      case 'slider',       hctrls(nr) = 1.5;
      case 'togglebutton', hctrls(nr) = 1.5;
    end
  end
  ctrls{nr,j} = varargin{i};
  j = j+1;
end;

vborder = 1;  hborder = 2;  hspace = 0.35;
height = 2*vborder + sum(hctrls)+(nr-1)*hspace + 1;

grp = uibuttongroup('Parent',parent, 'Title',title,...
                    'BackgroundColor', get(0,'DefaultUicontrolBackgroundColor'),...
                    'Units','characters', 'Position', [0,0,width,height]);
        
ctrl = [];   p = height-1-vborder;                
for i=1:size(ctrls,1)
  p = p - hctrls(i);
  par = {};
  for j=1:size(ctrls,2) 
    if ( ~isempty(ctrls{i,j}) ) par{j}=ctrls{i,j}; end 
  end
  h = uicontrol(par{:}, 'Parent',grp, 'Units','characters', 'Position',[3,p,width-4,1]);
  p = p-hspace;
  ctrl = [ctrl h];
end

if ( nargout < 3 ) clear ctrl; end
if ( nargout < 2 ) clear height; end

end

